package railcraft.client.core;

import cpw.mods.fml.common.TickType;
import java.util.EnumSet;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.client.gui.GuiChat;
import net.minecraft.client.settings.KeyBinding;
import org.lwjgl.input.Keyboard;
import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class AuraKeyHandler extends cpw.mods.fml.client.registry.KeyBindingRegistry.KeyHandler {

    private static KeyBinding anchorAura = new KeyBinding("Railcraft Anchor Aura", Keyboard.KEY_F9);
    private static KeyBinding tuningAura = new KeyBinding("Railcraft Tuning Aura", Keyboard.KEY_P);
    private static boolean anchorAuraEnabled = false;
    private static boolean tuningAuraEnabled = false;

    public AuraKeyHandler() {
        super(new KeyBinding[]{anchorAura, tuningAura}, new boolean[2]);
    }

    @Override
    public void keyDown(EnumSet<TickType> types, KeyBinding kb, boolean tickEnd, boolean isRepeat) {
        if (tickEnd) {
            if (Minecraft.getMinecraft().currentScreen instanceof GuiChat) {
                return;
            }
            EntityPlayer player = Minecraft.getMinecraft().thePlayer;
            if (kb == anchorAura) {
                anchorAuraEnabled = !anchorAuraEnabled;
                if (anchorAuraEnabled) {
                    String message = RailcraftLanguage.translate("gui.aura.enable");
                    String aura = RailcraftLanguage.translate("gui.goggles.aura.anchor");
                    player.addChatMessage(String.format(message, "\u00A75" + aura + "\u00A77"));
                } else {
                    String message = RailcraftLanguage.translate("gui.aura.disable");
                    String aura = RailcraftLanguage.translate("gui.goggles.aura.anchor");
                    player.addChatMessage(String.format(message, "\u00A75" + aura + "\u00A77"));
                }
            } else if (kb == tuningAura) {
                tuningAuraEnabled = !tuningAuraEnabled;
                if (tuningAuraEnabled) {
                    String message = RailcraftLanguage.translate("gui.aura.enable");
                    String aura = RailcraftLanguage.translate("gui.goggles.aura.tuning");
                    player.addChatMessage(String.format(message, "\u00A75" + aura + "\u00A77"));
                } else {
                    String message = RailcraftLanguage.translate("gui.aura.disable");
                    String aura = RailcraftLanguage.translate("gui.goggles.aura.tuning");
                    player.addChatMessage(String.format(message, "\u00A75" + aura + "\u00A77"));
                }
            }
        }
    }

    @Override
    public void keyUp(EnumSet<TickType> types, KeyBinding kb, boolean tickEnd) {
    }

    @Override
    public EnumSet<TickType> ticks() {
        return EnumSet.of(TickType.CLIENT);
    }

    @Override
    public String getLabel() {
        return "Railcraft Aura Key Handler";
    }

    public static boolean isAnchorAuraEnabled() {
        return anchorAuraEnabled;
    }

    public static boolean isTuningAuraEnabled() {
        return tuningAuraEnabled;
    }
}
