package railcraft.client.core;

import cpw.mods.fml.common.IScheduledTickHandler;
import cpw.mods.fml.common.TickType;
import java.util.EnumSet;
import net.minecraft.entity.player.EntityPlayer;
import railcraft.common.core.StartupChecks;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class LatestVersionMessage implements IScheduledTickHandler {

    private boolean messageSent;

    @Override
    public int nextTickSpacing() {
        return 300;
    }

    @Override
    public void tickStart(EnumSet<TickType> type, Object... tickData) {
        if (!messageSent && StartupChecks.isVersionCheckComplete()) {
            messageSent = true;
            if (StartupChecks.hasRailcraftUpdated()) {
                EntityPlayer player = (EntityPlayer) tickData[0];
                player.addChatMessage("Railcraft " + StartupChecks.getLatestVersion() + " is available from <http://railcraft.info>");
            }
        }
    }

    @Override
    public void tickEnd(EnumSet<TickType> type, Object... tickData) {
    }

    @Override
    public EnumSet<TickType> ticks() {
        if (messageSent) {
            return EnumSet.noneOf(TickType.class);
        }
        return EnumSet.of(TickType.PLAYER);
    }

    @Override
    public String getLabel() {
        return "Railcraft Update Check Message";
    }
}
