package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.blocks.machine.beta.TileBoilerFireboxSolid;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerBoilerSolid;
import railcraft.common.lang.RailcraftLanguage;

public class GuiBoilerSolid extends TileGui {

    private final TileBoilerFireboxSolid tile;

    public GuiBoilerSolid(InventoryPlayer inv, TileBoilerFireboxSolid tile) {
        super(tile, new ContainerBoilerSolid(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_boiler_solid.png");
        this.tile = tile;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        GuiTools.drawCenteredString(fontRenderer, RailcraftLanguage.translate("gui.steam.boiler"), 6);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }

    @Override
    protected void drawGuiContainerBackgroundLayer(float par1, int par2, int par3) {
        super.drawGuiContainerBackgroundLayer(par1, par3, par3);
        int x = (this.width - this.xSize) / 2;
        int y = (this.height - this.ySize) / 2;

        if (this.tile.isBurning()) {
            int scale = this.tile.getBurnProgressScaled(12);
            this.drawTexturedModalRect(x + 62, y + 34 - scale, 176, 59 - scale, 14, scale + 2);
        }
    }
}
