package railcraft.client.gui;

import cpw.mods.fml.common.network.PacketDispatcher;
import net.minecraft.client.gui.GuiButton;
import railcraft.common.blocks.signals.TileBoxCapacitor;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.util.misc.Game;
import railcraft.common.util.network.PacketGuiReturn;

public class GuiBoxCapacitor extends GuiBasic {

    private final TileBoxCapacitor tile;
    private short ticksToPower;

    public GuiBoxCapacitor(TileBoxCapacitor tile) {
        super(tile.getInvName());
        this.tile = tile;
        this.ticksToPower = tile.ticksToPower;
    }

    @Override
    public void initGui() {
        if (tile == null) {
            return;
        }
        controlList.clear();
        int w = (width - xSize) / 2;
        int h = (height - ySize) / 2;

        controlList.add(new GuiButton(0, w + 13, h + 50, 30, 20, "-10"));
        controlList.add(new GuiButton(1, w + 53, h + 50, 30, 20, "-1"));
        controlList.add(new GuiButton(2, w + 93, h + 50, 30, 20, "+1"));
        controlList.add(new GuiButton(3, w + 133, h + 50, 30, 20, "+10"));
    }

    @Override
    protected void drawExtras(int x, int y, float f) {
        GuiTools.drawCenteredString(fontRenderer, String.format(RailcraftLanguage.translate("gui.box.capacitor.duration"), ticksToPower / 20), 25);
    }

    @Override
    protected void actionPerformed(GuiButton guibutton) {
        short ticks = ticksToPower;
        if (guibutton.id == 0) {
            ticks += -200;
        }
        if (guibutton.id == 1) {
            ticks += -20;
        }
        if (guibutton.id == 2) {
            ticks += 20;
        }
        if (guibutton.id == 3) {
            ticks += 200;
        }
        if (ticks < 0) {
            ticks = 0;
        }
        ticksToPower = ticks;
    }

    @Override
    public void onGuiClosed() {
        if (Game.isNotHost(tile.getWorld())) {
            tile.ticksToPower = ticksToPower;
            PacketGuiReturn pkt = new PacketGuiReturn(tile);
            PacketDispatcher.sendPacketToServer(pkt.getPacket());
        }
    }
}
