package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.carts.EntityTunnelBore;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerBore;
import railcraft.common.lang.RailcraftLanguage;

public class GuiCartBore extends EntityGui {

    private static final String HEAD = RailcraftLanguage.translate("gui.bore.head");
    private static final String FUEL = RailcraftLanguage.translate("gui.bore.fuel");
    private static final String BALLAST = RailcraftLanguage.translate("gui.bore.ballast");
    private static final String TRACK = RailcraftLanguage.translate("gui.bore.track");
    private static final String LABEL = RailcraftLanguage.translate("cart.bore");
    private EntityTunnelBore cart;

    public GuiCartBore(InventoryPlayer inv, EntityTunnelBore cart) {
        super(cart, new ContainerBore(inv, cart), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_bore.png");
        this.cart = cart;
        xSize = 176;
        ySize = 222;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        GuiTools.drawCenteredString(fontRenderer, LABEL, 6);
        fontRenderer.drawString(HEAD, 13, 26, 0x404040);
        fontRenderer.drawString(FUEL, 64, 26, 0x404040);
        fontRenderer.drawString(BALLAST, 10, 62, 0x404040);
        fontRenderer.drawString(TRACK, 10, 98, 0x404040);
    }

    @Override
    protected void drawGuiContainerBackgroundLayer(float f, int i, int j) {
        super.drawGuiContainerBackgroundLayer(f, i, j);
        int w = (width - xSize) / 2;
        int h = (height - ySize) / 2;

        if (cart.getFuel() > 0) {
            int burnProgress = cart.getBurnProgressScaled(12);
            drawTexturedModalRect(w + 44, (h + 48) - burnProgress, 176, 12 - burnProgress, 14, burnProgress + 2);
        }
    }
}
