package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.carts.EntityCartEnergy;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerCartEnergy;

public class GuiCartEnergy extends EntityGui {

    private final EntityCartEnergy device;

    public GuiCartEnergy(InventoryPlayer inv, EntityCartEnergy cart) {
        super(cart, new ContainerCartEnergy(inv, cart), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_energy.png");
        this.device = cart;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        int sWidth = fontRenderer.getStringWidth(device.getInvName());
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(device.getInvName(), sPos, 6, 0x404040);
        fontRenderer.drawString("Power Level:", 80, 25, 0x404040);
        fontRenderer.drawString(Integer.toString(device.getEnergy()), 115, 35, 0x404040);

        StringBuilder capacity = new StringBuilder("/").append(device.getCapacity());
        fontRenderer.drawString(capacity.toString(), 115, 45, 0x404040);
    }

    @Override
    protected void drawGuiContainerBackgroundLayer(float f, int i, int j) {
        super.drawGuiContainerBackgroundLayer(f, i, j);
        int x = (width - xSize) / 2;
        int y = (height - ySize) / 2;

        if (device.getEnergy() > 0) {
            int energy = device.getEnergyBarScaled(24);
            drawTexturedModalRect(x + 79, y + 34, 176, 14, energy, 17);
        }
    }
}
