package railcraft.client.gui;

import cpw.mods.fml.common.network.PacketDispatcher;
import net.minecraft.client.gui.GuiButton;
import railcraft.common.carts.EntityCartTNT;
import railcraft.common.carts.EnumCart;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.util.misc.Game;
import railcraft.common.util.network.PacketBuilder;
import railcraft.common.util.network.PacketGuiReturn;

public class GuiCartTNTFuse extends GuiBasic {

    private static final String LABEL = RailcraftLanguage.translate(EnumCart.TNT.getTag());
    private static final String FUSE = RailcraftLanguage.translate("gui.cart.tnt.fuse") + " = ";
    private static final String TICKS = " " + RailcraftLanguage.translate("gui.ticks");
    protected int fuse = 80;
    EntityCartTNT cart;

    public GuiCartTNTFuse(EntityCartTNT c) {
        super(LABEL);
        cart = c;
        if (cart != null) {
            fuse = cart.getFuse();
        }
    }

    @Override
    public void initGui() {
        controlList.clear();
        int w = (width - xSize) / 2;
        int h = (height - ySize) / 2;
        controlList.add(new GuiButton(0, w + 13, h + 50, 30, 20, "-10"));
        controlList.add(new GuiButton(1, w + 53, h + 50, 30, 20, "-1"));
        controlList.add(new GuiButton(2, w + 93, h + 50, 30, 20, "+1"));
        controlList.add(new GuiButton(3, w + 133, h + 50, 30, 20, "+10"));
    }

    @Override
    protected void actionPerformed(GuiButton guibutton) {
        int f = fuse;
        if (guibutton.id == 0) {
            f += -10;
        }
        if (guibutton.id == 1) {
            f += -1;
        }
        if (guibutton.id == 2) {
            f += 1;
        }
        if (guibutton.id == 3) {
            f += 10;
        }
        if (f < EntityCartTNT.MIN_FUSE) {
            f = EntityCartTNT.MIN_FUSE;
        }
        if (f > EntityCartTNT.MAX_FUSE) {
            f = EntityCartTNT.MAX_FUSE;
        }
        fuse = f;
    }

    @Override
    public void drawExtras(int x, int y, float f) {
        if (cart != null) {
            GuiTools.drawCenteredString(fontRenderer, FUSE + fuse + TICKS, 25);
        }
    }

    @Override
    public void onGuiClosed() {
        cart.setFuse(fuse);
        if (Game.isNotHost(cart.getWorld())) {
            PacketBuilder.getInstance().sendGuiReturnPacket(cart);
        }
    }
}
