package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.carts.EntityCartTank;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerTankCart;
import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class GuiCartTank extends EntityGui
{

    private final String label;
    private final EntityCartTank cart;

    public GuiCartTank(InventoryPlayer inv, EntityCartTank cart)
    {
        super(cart, new ContainerTankCart(inv, cart), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_cart_tank.png");
        this.cart = cart;
        label = cart.getInvName();
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.filter"), 67, 27, 0x404040);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }
}
