package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.carts.EntityCartTrackRelayer;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerTrackRelayer;
import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class GuiCartTrackRelayer extends EntityGui {

    private final String label;
    private EntityCartTrackRelayer cart;

    public GuiCartTrackRelayer(InventoryPlayer inv, EntityCartTrackRelayer cart) {
        super(cart, new ContainerTrackRelayer(inv, cart), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_cart_track_relayer.png");
        label = cart.getInvName();
        this.cart = cart;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.cart.track.relayer.pattern"), 38, 30, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.cart.track.relayer.stock"), 125, 25, 0x404040);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }
}
