package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.carts.EntityCartUndercutter;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerUndercutter;
import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class GuiCartUndercutter extends EntityGui
{

    private final String label;

    public GuiCartUndercutter(InventoryPlayer inv, EntityCartUndercutter cart)
    {
        super(cart, new ContainerUndercutter(inv, cart), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_cart_undercutter.png");
        label = cart.getInvName();
        ySize = 205;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.cart.undercutter.pattern"), 8, 32, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.cart.undercutter.stock"), 125, 30, 0x404040);
        GuiTools.drawCenteredString(fontRenderer, RailcraftLanguage.translate("gui.cart.undercutter.under"), 32);
        GuiTools.drawCenteredString(fontRenderer, RailcraftLanguage.translate("gui.cart.undercutter.sides"), 74);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }
}
