package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.blocks.machine.alpha.TileCokeOven;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerCokeOven;
import railcraft.common.lang.RailcraftLanguage;

public class GuiCokeOven extends TileGui {

    private TileCokeOven tile;

    public GuiCokeOven(InventoryPlayer inventoryplayer, TileCokeOven tile) {
        super(tile, new ContainerCokeOven(inventoryplayer, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_coke_oven.png");
        this.tile = tile;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        GuiTools.drawCenteredString(fontRenderer, RailcraftLanguage.translate("gui.coke.oven"), 6);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }

    @Override
    protected void drawGuiContainerBackgroundLayer(float f, int i, int j) {
        super.drawGuiContainerBackgroundLayer(f, i, j);
        int x = (width - xSize) / 2;
        int y = (height - ySize) / 2;

        if (tile.getCookTime() > 0) {
            int burnProgress = tile.getBurnProgressScaled(12);
            drawTexturedModalRect(x + 16, (y + 38) - burnProgress, 176, 59 - burnProgress, 14, burnProgress + 2);
            int cookProgress = tile.getCookProgressScaled(20);
            drawTexturedModalRect(x + 34, y + 43, 176, 61, cookProgress + 1, 16);
        }
    }
}
