package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.blocks.detector.TileDetectorAdvanced;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerDetectorAdvanced;
import railcraft.common.lang.RailcraftLanguage;

public class GuiDetectorAdvanced extends TileGui {

    private static final String label = RailcraftLanguage.translate("detector.advanced");
    private final TileDetectorAdvanced tile;

    public GuiDetectorAdvanced(InventoryPlayer inv, TileDetectorAdvanced tile) {
        super(tile, new ContainerDetectorAdvanced(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_detector_advanced.png");
        this.tile = tile;
        xSize = 176;
        ySize = 140;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
    }
}
