package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.blocks.detector.TileDetectorLocomotive;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerDetectorLocomotive;
import railcraft.common.lang.RailcraftLanguage;

public class GuiDetectorLocomotive extends TileGui
{

    private static final String label = RailcraftLanguage.translate("detector.locomotive");
    private final TileDetectorLocomotive tile;

    public GuiDetectorLocomotive(InventoryPlayer inv, TileDetectorLocomotive tile)
    {
        super(tile, new ContainerDetectorLocomotive(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_double_slot.png");
        this.tile = tile;
        xSize = 176;
        ySize = 170;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.detector.loco.primary"), 60, 31, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.detector.loco.secondary"), 60, 57, 0x404040);
    }
}
