package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.blocks.detector.TileDetectorSheep;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerDetectorSheep;
import railcraft.common.lang.RailcraftLanguage;

public class GuiDetectorSheep extends TileGui
{

    private static final String label = RailcraftLanguage.translate("detector.sheep");
    private final TileDetectorSheep tile;

    public GuiDetectorSheep(InventoryPlayer inv, TileDetectorSheep tile)
    {
        super(tile, new ContainerDetectorSheep(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_single_slot.png");
        this.tile = tile;
        xSize = 176;
        ySize = 140;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.filter"), 85, 29, 0x404040);
    }
}
