package railcraft.client.gui;

import cpw.mods.fml.common.network.PacketDispatcher;
import net.minecraft.client.gui.GuiButton;
import railcraft.common.blocks.detector.TileDetectorTrain;
import railcraft.common.util.misc.Game;
import railcraft.common.util.network.PacketGuiReturn;

public class GuiDetectorTrain extends GuiBasic
{

    private static final String LABEL = "Detector - Train";
    protected short trainSize = 5;
    TileDetectorTrain tile;

    public GuiDetectorTrain(TileDetectorTrain t)
    {
        super(LABEL);
        tile = t;
        if(tile != null) {
            trainSize = tile.getTrainSize();
        }
    }

    @Override
    public void initGui()
    {
        controlList.clear();
        int w = (width - xSize) / 2;
        int h = (height - ySize) / 2;
        controlList.add(new GuiButton(0, w + 13, h + 50, 30, 20, "-10"));
        controlList.add(new GuiButton(1, w + 53, h + 50, 30, 20, "-1"));
        controlList.add(new GuiButton(2, w + 93, h + 50, 30, 20, "+1"));
        controlList.add(new GuiButton(3, w + 133, h + 50, 30, 20, "+10"));
    }

    @Override
    protected void drawExtras(int x, int y, float f)
    {
        GuiTools.drawCenteredString(fontRenderer, "Train Size = " + trainSize, 25);
    }

    @Override
    protected void actionPerformed(GuiButton guibutton)
    {
        short f = trainSize;
        if(guibutton.id == 0) {
            f += -10;
        }
        if(guibutton.id == 1) {
            f += -1;
        }
        if(guibutton.id == 2) {
            f += 1;
        }
        if(guibutton.id == 3) {
            f += 10;
        }
        if(f < 1) {
            f = 1;
        }
        if(f > 100) {
            f = 100;
        }
        trainSize = f;
    }

    @Override
    public void onGuiClosed()
    {
        tile.setTrainSize(trainSize);
        if(Game.isNotHost(tile.getWorld())) {
            PacketGuiReturn pkt = new PacketGuiReturn(tile);
            PacketDispatcher.sendPacketToServer(pkt.getPacket());
        }
    }
}
