package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.blocks.machine.gamma.TileDispenserTrain;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerDispenserTrain;

public class GuiDispenserTrain extends TileGui
{

    private static final String LABEL = "Train Dispenser";

    public GuiDispenserTrain(InventoryPlayer inv, TileDispenserTrain tile)
    {
        super(tile, new ContainerDispenserTrain(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_dispenser_train.png");
        xSize = 176;
        ySize = 198;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        int sWidth = fontRenderer.getStringWidth(LABEL);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(LABEL, sPos, 6, 0x404040);
        fontRenderer.drawString("Pattern", 10, 20, 0x404040);
        fontRenderer.drawString("Buffer", 10, 56, 0x404040);
    }
}
