package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.blocks.machine.beta.TileEngineSteam;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerEngineSteam;

public class GuiEngineSteam extends TileGui
{

    private static final String OUTPUT = "%3.1f MJ";
    private final TileEngineSteam tile;

    public GuiEngineSteam(InventoryPlayer inv, TileEngineSteam tile)
    {
        super(tile, new ContainerEngineSteam(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_engine_steam.png");
        this.tile = tile;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        GuiTools.drawCenteredString(fontRenderer, tile.getInvName(), 6);
        fontRenderer.drawString(String.format(OUTPUT, tile.getCurrentOutput()), 120, 40, 0x404040);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }
}
