package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.blocks.machine.beta.TileEngineSteamHobby;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerEngineSteamHobby;

public class GuiEngineSteamHobby extends TileGui
{

    private static final String OUTPUT = "%3.1f MJ";
    private final TileEngineSteamHobby tile;

    public GuiEngineSteamHobby(InventoryPlayer inv, TileEngineSteamHobby tile)
    {
        super(tile, new ContainerEngineSteamHobby(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_engine_hobby.png");
        this.tile = tile;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        GuiTools.drawCenteredString(fontRenderer, tile.getInvName(), 6);
        fontRenderer.drawString(String.format(OUTPUT, tile.getCurrentOutput()), 55, 60, 0x404040);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }

    @Override
    protected void drawGuiContainerBackgroundLayer(float par1, int par2, int par3)
    {
        super.drawGuiContainerBackgroundLayer(par1, par3, par3);
        int x = (this.width - this.xSize) / 2;
        int y = (this.height - this.ySize) / 2;

        if(this.tile.isBurning()) {
            int scale = this.tile.getBurnProgressScaled(12);
            this.drawTexturedModalRect(x + 62, y + 34 - scale, 176, 59 - scale, 14, scale + 2);
        }
    }
}
