package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.blocks.machine.alpha.EnumMachineAlpha;
import railcraft.common.blocks.machine.alpha.TileFeedStation;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerFeedStation;
import railcraft.common.lang.RailcraftLanguage;

public class GuiFeedStation extends TileGui {

    private static final String label = RailcraftLanguage.translate(EnumMachineAlpha.FEED_STATION.getTag());
    private static final String feed = RailcraftLanguage.translate("gui.feed.station.feed");

    public GuiFeedStation(InventoryPlayer playerInv, TileFeedStation tile) {
        super(tile, new ContainerFeedStation(playerInv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_single_slot.png");
        xSize = 176;
        ySize = 140;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
        fontRenderer.drawString(feed, 85, 29, 0x404040);
    }
}
