package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.blocks.RailcraftTileEntity;
import railcraft.common.blocks.machine.ITankTile;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerTank;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class GuiTank extends TileGui
{

    private ITankTile tile;

    public GuiTank(InventoryPlayer inv, ITankTile tile)
    {
        super((RailcraftTileEntity)tile, new ContainerTank(inv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_tank_water.png");
        this.tile = tile;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        int sWidth = fontRenderer.getStringWidth(tile.getInventory().getInvName());
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(tile.getInventory().getInvName(), sPos, 6, 0x404040);
//        fontRenderer.drawString(RailcraftLanguage.translate("gui.liquid.capacity") + ": " + tile.getTanks()[0].getCapacity(), 30, 100, 0x404040);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }
}
