package railcraft.client.gui;

import java.util.List;
import net.minecraft.client.gui.FontRenderer;
import railcraft.client.gui.buttons.GuiBetterButton;

public class GuiTools
{

    public static void drawCenteredString(FontRenderer fr, String s, int y)
    {
        drawCenteredString(fr, s, y, 176);
    }

    public static void drawCenteredString(FontRenderer fr, String s, int y, int guiWidth)
    {
        drawCenteredString(fr, s, y, guiWidth, 0x404040);
    }

    public static void drawCenteredString(FontRenderer fr, String s, int y, int guiWidth, int color)
    {
        int sWidth = fr.getStringWidth(s);
        int sPos = guiWidth / 2 - sWidth / 2;
        fr.drawString(s, sPos, y, 0x404040);
    }

    public static void newButtonRowAuto(List controlList, int xStart, int xSize, List<GuiBetterButton> buttons)
    {
        int buttonWidth = 0;
        for(GuiBetterButton b : buttons) {
            buttonWidth += b.getWidth();
        }
        int remaining = xSize - buttonWidth;
        int spacing = remaining / (buttons.size() + 1);
        int pointer = 0;
        for(GuiBetterButton b : buttons) {
            pointer += spacing;
            b.xPosition = xStart + pointer;
            pointer += b.getWidth();
            controlList.add(b);
        }
    }

    public static void newButtonRow(List controlList, int xStart, int spacing, List<GuiBetterButton> buttons)
    {
        int pointer = 0;
        for(GuiBetterButton b : buttons) {
            b.xPosition = xStart + pointer;
            pointer += b.getWidth() + spacing;
            controlList.add(b);
        }
    }
}
