package railcraft.client.gui;

import net.minecraft.client.gui.GuiButton;
import railcraft.common.blocks.tracks.TrackLauncher;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.util.misc.Game;
import railcraft.common.util.network.IGuiReturnHandler;
import railcraft.common.util.network.PacketGuiReturn;

public class GuiTrackLauncher extends GuiBasic
{

    protected int force = 25;
    TrackLauncher track;

    public GuiTrackLauncher(TrackLauncher t)
    {
        super(RailcraftLanguage.translate(t.getTrackType().getTag()));
        track = t;
        if(track != null)
        {
            force = track.getLaunchForce();
        }
    }

    @Override
    public void initGui()
    {
        controlList.clear();
        int w = (width - xSize) / 2;
        int h = (height - ySize) / 2;
        controlList.add(new GuiButton(0, w + 13, h + 50, 30, 20, "-10"));
        controlList.add(new GuiButton(1, w + 53, h + 50, 30, 20, "-1"));
        controlList.add(new GuiButton(2, w + 93, h + 50, 30, 20, "+1"));
        controlList.add(new GuiButton(3, w + 133, h + 50, 30, 20, "+10"));
    }

    @Override
    protected void actionPerformed(GuiButton guibutton)
    {
        int f = force;
        if(guibutton.id == 0)
        {
            f += -10;
        }
        if(guibutton.id == 1)
        {
            f += -1;
        }
        if(guibutton.id == 2)
        {
            f += 1;
        }
        if(guibutton.id == 3)
        {
            f += 10;
        }
        if(f < TrackLauncher.MIN_LAUNCH_FORCE)
        {
            f = TrackLauncher.MIN_LAUNCH_FORCE;
        }
        if(f > RailcraftConfig.getLaunchRailMaxForce())
        {
            f = RailcraftConfig.getLaunchRailMaxForce();
        }
        force = f;
    }

    @Override
    public void drawExtras(int x, int y, float f)
    {
        if(track != null)
        {
            fontRenderer.drawString("Force = " + force, 61, 25, 0x404040);
        }
    }

    @Override
    public void onGuiClosed()
    {
        track.setLaunchForce(force);
        if(Game.isNotHost(track.getWorld())) {
            PacketGuiReturn pkt = new PacketGuiReturn((IGuiReturnHandler)track.tileEntity);
            pkt.sendPacket();
        }
    }
}
