package railcraft.client.gui;

import cpw.mods.fml.common.network.PacketDispatcher;
import net.minecraft.client.gui.GuiButton;
import railcraft.common.blocks.tracks.TrackPriming;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.util.misc.Game;
import railcraft.common.util.network.IGuiReturnHandler;
import railcraft.common.util.network.PacketGuiReturn;

public class GuiTrackPriming extends GuiBasic {

    protected short fuse = 80;
    TrackPriming track;

    public GuiTrackPriming(TrackPriming t) {
        super(RailcraftLanguage.translate(t.getTrackSpec().getTrackTag()));
        track = t;
        fuse = track.getFuse();
    }

    @Override
    public void initGui() {
        controlList.clear();
        int w = (width - xSize) / 2;
        int h = (height - ySize) / 2;
        controlList.add(new GuiButton(0, w + 13, h + 50, 30, 20, "-10"));
        controlList.add(new GuiButton(1, w + 53, h + 50, 30, 20, "-1"));
        controlList.add(new GuiButton(2, w + 93, h + 50, 30, 20, "+1"));
        controlList.add(new GuiButton(3, w + 133, h + 50, 30, 20, "+10"));
    }

    @Override
    protected void drawExtras(int x, int y, float f) {
        GuiTools.drawCenteredString(fontRenderer, String.format(RailcraftLanguage.translate("gui.track.priming.fuse"), fuse), 25);
    }

    @Override
    protected void actionPerformed(GuiButton guibutton) {
        short f = fuse;
        if (guibutton.id == 0) {
            f += -10;
        }
        if (guibutton.id == 1) {
            f += -1;
        }
        if (guibutton.id == 2) {
            f += 1;
        }
        if (guibutton.id == 3) {
            f += 10;
        }
        if (f < TrackPriming.MIN_FUSE) {
            f = TrackPriming.MIN_FUSE;
        }
        if (f > TrackPriming.MAX_FUSE) {
            f = TrackPriming.MAX_FUSE;
        }
        fuse = f;
    }

    @Override
    public void onGuiClosed() {
        track.setFuse(fuse);
        if (Game.isNotHost(track.getWorld())) {
            PacketGuiReturn pkt = new PacketGuiReturn((IGuiReturnHandler) track.tileEntity);
            PacketDispatcher.sendPacketToServer(pkt.getPacket());
        }
    }
}
