package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import railcraft.common.blocks.machine.alpha.TileSteamTurbine;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerTurbine;
import railcraft.common.lang.RailcraftLanguage;

public class GuiTurbine extends TileGui
{

    private final String label;
    private final TileSteamTurbine tile;

    public GuiTurbine(InventoryPlayer playerInv, TileSteamTurbine tile) {
        super(tile, new ContainerTurbine(playerInv, tile), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_single_slot.png");
        xSize = 176;
        ySize = 140;

        label = RailcraftLanguage.translate("gui.turbine");
        this.tile = tile;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        GuiTools.drawCenteredString(fontRenderer, label, 6);
        fontRenderer.drawString(RailcraftLanguage.translate("gui.turbine.rotor"), 20, 29, 0x404040);
        fontRenderer.drawString(String.format(RailcraftLanguage.translate("gui.turbine.output"), Math.round(tile.output)), 95, 29, 0x404040);
    }
}
