package railcraft.client.gui;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.util.StatCollector;
import railcraft.common.blocks.machine.alpha.TileAnchorWorld;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.gui.containers.ContainerAnchor;
import railcraft.common.lang.RailcraftLanguage;

public class GuiWorldAnchor extends TileGui {

    private final TileAnchorWorld tile;
    private static final String pearls = RailcraftLanguage.translate("gui.anchor.fuel");
    private static final String remeining = RailcraftLanguage.translate("gui.anchor.fuel.remaining");
    private ContainerAnchor container;

    public GuiWorldAnchor(InventoryPlayer playerInv, TileAnchorWorld anchor) {
        super(anchor, new ContainerAnchor(playerInv, anchor), RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_single_slot.png");
        xSize = 176;
        ySize = 140;
        this.tile = anchor;
        container = (ContainerAnchor) inventorySlots;
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY) {
        String label = tile.getInvName();
        int sWidth = fontRenderer.getStringWidth(label);
        int sPos = xSize / 2 - sWidth / 2;
        fontRenderer.drawString(label, sPos, 6, 0x404040);
        fontRenderer.drawString(pearls, 85, 24, 0x404040);
        fontRenderer.drawString(String.format(remeining, (double) container.minutesRemaining / 60), 85, 35, 0x404040);
        fontRenderer.drawString(StatCollector.translateToLocal("container.inventory"), 8, (ySize - 96) + 2, 0x404040);
    }
}
