package railcraft.client.gui.buttons;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import org.lwjgl.opengl.GL11;
import railcraft.common.gui.util.MultiButtonController;
import railcraft.common.core.RailcraftConstants;

public class GuiMultiButton extends GuiBetterButton {

    private final MultiButtonController control;

    public GuiMultiButton(int id, int x, int y, int width, MultiButtonController control) {
        super(id, x, y, width, 20, "");
        this.control = control.copy();
    }

    @Override
    public void drawButton(Minecraft minecraft, int i, int j) {
        if (!drawButton) {
            return;
        }
        FontRenderer fontrenderer = minecraft.fontRenderer;
        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, minecraft.renderEngine.getTexture(RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_basic.png"));
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        boolean flag = i >= xPosition && j >= yPosition && i < xPosition + width && j < yPosition + height;
        int hoverState = getHoverState(flag);
        drawTexturedModalRect(xPosition, yPosition, 0, 88 + hoverState * 20, width / 2, height);
        drawTexturedModalRect(xPosition + width / 2, yPosition, 200 - width / 2, 88 + hoverState * 20, width / 2, height);
        mouseDragged(minecraft, i, j);
        displayString = control.getButtonState().getLabel();
        if (!enabled) {
            drawCenteredString(fontrenderer, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, 0xffa0a0a0);
        } else if (flag) {
            drawCenteredString(fontrenderer, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, 0xffffa0);
        } else {
            drawCenteredString(fontrenderer, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, 0xe0e0e0);
        }
    }

    @Override
    public boolean mousePressed(Minecraft par1Minecraft, int par2, int par3) {
        boolean pressed = super.mousePressed(par1Minecraft, par2, par3);
        if (pressed) {
            control.incrementState();
        }
        return pressed;
    }

    public MultiButtonController getController() {
        return control;
    }
}
