package railcraft.client.render;

import railcraft.common.blocks.RailcraftBlocks;
import railcraft.common.blocks.machine.beta.EnumMachineBeta;
import railcraft.common.core.RailcraftConstants;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class RenderBlockMachineBeta extends BlockRenderer
{

    public RenderBlockMachineBeta()
    {
        super(RailcraftBlocks.getBlockMachineBeta());

        addBlockRenderer(EnumMachineBeta.BOILER_TANK_LOW_PRESSURE.ordinal(), new RenderBoilerTank());
        addBlockRenderer(EnumMachineBeta.BOILER_TANK_HIGH_PRESSURE.ordinal(), new RenderBoilerTank());

        addBlockRenderer(EnumMachineBeta.ENGINE_STEAM_HOBBY.ordinal(), new DoNothingRenderer());
        addItemRenderer(EnumMachineBeta.ENGINE_STEAM_HOBBY.ordinal(), new RenderPneumaticEngine(RailcraftConstants.ENGINE_TEXTURE_FOLDER + "steam_hobby.png"));

        addBlockRenderer(EnumMachineBeta.ENGINE_STEAM_LOW.ordinal(), new DoNothingRenderer());
        addItemRenderer(EnumMachineBeta.ENGINE_STEAM_LOW.ordinal(), new RenderPneumaticEngine(RailcraftConstants.ENGINE_TEXTURE_FOLDER + "steam_low.png"));

        addBlockRenderer(EnumMachineBeta.ENGINE_STEAM_HIGH.ordinal(), new DoNothingRenderer());
        addItemRenderer(EnumMachineBeta.ENGINE_STEAM_HIGH.ordinal(), new RenderPneumaticEngine(RailcraftConstants.ENGINE_TEXTURE_FOLDER + "steam_high.png"));

        addCombinedRenderer(EnumMachineBeta.SENTINEL.ordinal(), new RenderSentinel());
    }
}
