package railcraft.client.render;

import railcraft.common.api.signals.SignalAspect;
import railcraft.common.blocks.RailcraftBlocks;
import railcraft.common.blocks.signals.EnumSignal;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class RenderBlockSignal extends BlockRenderer
{

    public RenderBlockSignal() {
        super(RailcraftBlocks.getBlockSignal());

        addCombinedRenderer(EnumSignal.DUAL_HEAD_BLOCK_SIGNAL.ordinal(), new RenderDualHeadSignal());
        addCombinedRenderer(EnumSignal.DUAL_HEAD_DISTANT_SIGNAL.ordinal(), new RenderDualHeadSignal());
        addCombinedRenderer(EnumSignal.BLOCK_SIGNAL.ordinal(), new RenderSignal(EnumSignal.BLOCK_SIGNAL, SignalAspect.GREEN));
        addCombinedRenderer(EnumSignal.DISTANT_SIGNAL.ordinal(), new RenderSignal(EnumSignal.DISTANT_SIGNAL, SignalAspect.RED));
        addCombinedRenderer(EnumSignal.SWITCH_MOTOR.ordinal(), new RenderSwitch(EnumSignal.SWITCH_MOTOR));
        addCombinedRenderer(EnumSignal.SWITCH_LEVER.ordinal(), new RenderSwitch(EnumSignal.SWITCH_LEVER));
        addCombinedRenderer(EnumSignal.BOX_RECEIVER.ordinal(), new RenderSignalBox());
        addCombinedRenderer(EnumSignal.BOX_CONTROLLER.ordinal(), new RenderSignalBox());
        addCombinedRenderer(EnumSignal.BOX_CAPACITOR.ordinal(), new RenderSignalBox());
        addCombinedRenderer(EnumSignal.BOX_BLOCK_RELAY.ordinal(), new RenderSignalBox());
    }
}
