package railcraft.client.render;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.util.MathHelper;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.world.World;
import net.minecraftforge.client.ForgeHooksClient;
import org.lwjgl.opengl.GL11;
import railcraft.common.blocks.aesthetics.cube.EntityFallingCube;

public class RenderFallingCube extends Render
{

    public RenderFallingCube()
    {
        this.shadowSize = 0.5F;
    }

    /**
     * The actual render method that is used in doRender
     */
    public void doRenderFallingCube(EntityFallingCube entity, double x, double y, double z, float par8, float par9)
    {
        Block block = Block.blocksList[entity.blockID];
        if(block != null) {
            GL11.glPushMatrix();
            GL11.glTranslatef((float)x, (float)y, (float)z);
            ForgeHooksClient.bindTexture(block.getTextureFile(), 0);
            World world = entity.getWorld();
            GL11.glDisable(GL11.GL_LIGHTING);
            renderBlocks.setRenderBoundsFromBlock(block);
            renderBlocks.renderBlockSandFalling(block, world, MathHelper.floor_double(entity.posX), MathHelper.floor_double(entity.posY), MathHelper.floor_double(entity.posZ), entity.metadata);
            GL11.glEnable(GL11.GL_LIGHTING);
            GL11.glPopMatrix();
        }
    }

    /**
     * Actually renders the given argument. This is a synthetic bridge method, always casting down its argument and then
     * handing it off to a worker function which does the actual work. In all probabilty, the class Render is generic
     * (Render<T extends Entity) and this method has signature public void doRender(T entity, double d, double d1,
     * double d2, float f, float f1). But JAD is pre 1.5 so doesn't do that.
     */
    @Override
    public void doRender(Entity par1Entity, double par2, double par4, double par6, float par8, float par9)
    {
        this.doRenderFallingCube((EntityFallingCube)par1Entity, par2, par4, par6, par8, par9);
    }
}
