/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.client.render.carts;

import net.minecraft.client.model.ModelBase;
import net.minecraft.entity.item.EntityMinecart;
import org.lwjgl.opengl.GL11;
import railcraft.common.carts.EntityLocomotive;
import railcraft.common.util.misc.EnumColor;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class LocomotiveRenderer extends CartModelRenderer {

    @Override
    public void render(RenderCart renderer, EntityMinecart cart, float light) {
        EntityLocomotive loco = (EntityLocomotive)cart;
        String[] textures = loco.getLocomotiveTextures();

        ModelBase model = CartModelManager.getModel(cart.getClass());

        for (int pass = 0; pass < 3; pass++) {
            renderer.bindTexture(textures[pass]);

            int color = 0xFFFFFF;
            switch (pass) {
                case 0:
                    color = EnumColor.fromId(loco.getPrimaryColor()).getHexColor();
                    break;
                case 1:
                    color = EnumColor.fromId(loco.getSecondaryColor()).getHexColor();
                    break;
            }

            float dim = light;
            float c1 = (float) (color >> 16 & 255) / 255.0F;
            float c2 = (float) (color >> 8 & 255) / 255.0F;
            float c3 = (float) (color & 255) / 255.0F;
            GL11.glColor4f(c1 * dim, c2 * dim, c3 * dim, 1);
            model.render(cart, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
        }
    }
}
