/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.client.render.carts;

import net.minecraft.entity.item.EntityMinecart;
import org.lwjgl.opengl.GL11;
import railcraft.client.render.RenderFakeBlock;
import railcraft.common.carts.MaintanceCartBase;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.util.misc.FakeBlockRenderInfo;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class SubRenderCartMaintance extends SubRenderCart {

    private static final int LIGHT_ON_TEXTURE = 209;
    private static final int LIGHT_OFF_TEXTURE = 210;
    private static final int LIGHT_BASE_TEXTURE = 211;
    private final FakeBlockRenderInfo fakeBlock = new FakeBlockRenderInfo();
    private final FakeBlockRenderInfo lightBlock = new FakeBlockRenderInfo(6f / 16f, 6f / 16f, 6f / 16f, 10f / 16f, 10f / 16f, 10f / 16f);
    private final FakeBlockRenderInfo lightBaseBlock = new FakeBlockRenderInfo(5f / 16f, 0, 5f / 16f, 11f / 16f, 1f / 16f, 11f / 16f);
    private final RenderCart renderCart;

    public SubRenderCartMaintance(RenderCart render) {
        this.renderCart = render;
        lightBaseBlock.texture[0] = LIGHT_BASE_TEXTURE;
    }

    @Override
    public void render(EntityMinecart cart, float light, float time) {
        MaintanceCartBase maintCart = (MaintanceCartBase) cart;
        GL11.glPushMatrix();
        GL11.glTranslatef(0.0F, 0.3125F, 0.0F);
        GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
        GL11.glDisable(2896 /*GL_LIGHTING*/);
        renderCart.bindTexture(RailcraftConstants.MAIN_TEXTURE_FILE);

        int x = (int) (Math.floor(cart.posX));
        int y = (int) (Math.floor(cart.posY));
        int z = (int) (Math.floor(cart.posZ));

        fakeBlock.texture = maintCart.getTextureArray();
        RenderFakeBlock.renderBlockForEntity(fakeBlock, cart.worldObj, x, y, z, true, true);
        RenderFakeBlock.renderBlock(lightBaseBlock, cart.worldObj, -0.5, 0.5, -0.5, x, y + 1, z, true, true);
        if (maintCart.isBlinking()) {
            lightBlock.texture[0] = LIGHT_ON_TEXTURE;
            lightBlock.light = 1;
            lightBlock.brightness = 200;
        } else {
            lightBlock.texture[0] = LIGHT_OFF_TEXTURE;
            lightBlock.light = 1;
            lightBlock.brightness = -1;
        }

        RenderFakeBlock.renderBlock(lightBlock, cart.worldObj, -0.5, 2f / 16f, -0.5, x, y + 1, z, lightBlock.brightness > 0, true);

        GL11.glEnable(2896 /*GL_LIGHTING*/);
        GL11.glPopMatrix();
    }
}
