/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.client.render.carts;

import net.minecraft.block.Block;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.client.renderer.RenderBlocks;
import org.lwjgl.opengl.GL11;
import railcraft.common.api.carts.ICartRenderInterface;
import railcraft.common.carts.EntityCartTNT;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class SubRenderCartTNT extends SubRenderCart {

    private final RenderCart renderCart;

    public SubRenderCartTNT(RenderCart render) {
        this.renderCart = render;
    }

    @Override
    public void render(EntityMinecart cart, float light, float time) {
        Block block = ((ICartRenderInterface) cart).getBlock();
        int meta = ((ICartRenderInterface) cart).getBlockMetadata();

        GL11.glPushMatrix();
        renderCart.bindTexture("/terrain.png");
        GL11.glTranslatef(0.0F, 0.3125F, 0.0F);
        GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
        EntityCartTNT tnt = (EntityCartTNT) cart;
        if (tnt.isPrimed() && ((float) tnt.getFuse() - time) + 1.0F < 10F) {
            float scale = 1.0F - (((float) tnt.getFuse() - time) + 1.0F) / 10F;
            if (scale < 0.0F) {
                scale = 0.0F;
            }
            if (scale > 1.0F) {
                scale = 1.0F;
            }
            scale *= scale;
            scale *= scale;
            scale = 1.0F + scale * 0.3F;
            GL11.glScalef(scale, scale, scale);
        }
        renderCart.renderBlocks().renderBlockAsItem(block, meta, light);
        if (tnt.isPrimed() && (tnt.getFuse() / 5) % 2 == 0) {
            GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
            GL11.glDisable(2896 /*GL_LIGHTING*/);
            GL11.glEnable(3042 /*GL_BLEND*/);
            GL11.glBlendFunc(770, 772);
            float alpha = (1.0F - (((float) tnt.getFuse() - time) + 1.0F) / 100F) * 0.8F;
            GL11.glColor4f(1.0F, 1.0F, 1.0F, alpha);
            GL11.glScalef(1.01f, 1.01f, 1.01f);
            renderCart.renderBlocks().renderBlockAsItem(block, meta, 1.0F);
            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
            GL11.glDisable(3042 /*GL_BLEND*/);
            GL11.glEnable(2896 /*GL_LIGHTING*/);
            GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
        }
        GL11.glPopMatrix();
    }
}
