package railcraft.common.blocks.aesthetics.cube;

import java.util.Random;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.world.World;

public abstract class CubeClass
{

    public int getBlockTextureFromSide(int side)
    {
        int[] texture = getTexture();
        if(side >= 0 && side < texture.length) {
            return texture[side];
        }
        return texture[0];
    }

    public boolean canCreatureSpawn(EnumCreatureType type, World world, int x, int y, int z)
    {
        return true;
    }

    public void updateTick(World world, int i, int j, int k, Random rand)
    {
    }

    public void onNeighborBlockChange(World world, int i, int j, int k, int id)
    {
    }

    public void onBlockPlaced(World world, int i, int j, int k)
    {
    }

    public void randomDisplayTick(World world, int i, int j, int k, Random rand)
    {
    }

    public void onBlockAdded(World world, int i, int j, int k)
    {
    }

    public void onBlockRemoval(World world, int i, int j, int k)
    {
    }

    public boolean removeBlockByPlayer(World world, EntityPlayer player, int i, int j, int k)
    {
        return world.setBlockWithNotify(i, j, k, 0);
    }

    public int getBlockId()
    {
        Block block = BlockCube.getBlock();
        if(block == null) {
            return 0;
        }
        return BlockCube.getBlock().blockID;
    }

    public abstract int[] getTexture();
}
