package railcraft.common.blocks.aesthetics.cube;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.item.ItemStack;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.modules.ModuleManager;
import railcraft.common.modules.ModuleManager.Module;

/**
 *
 * @author CovertJaguar
 */
public enum EnumCube {

    @Deprecated
    WORLD_ANCHOR(Module.AUTOMATION, "world.anchor", new WorldAnchor(), 10f, 60f),
    CONCRETE_BLOCK(Module.STRUCTURES, "concrete.block", new ConcreteBlock(), 3f, 15f),
    STEEL_BLOCK(Module.FACTORY, "steel.block", new SteelBlock(), 5f, 15f),
    INFERNAL_BRICK(Module.STRUCTURES, "brick.infernal", new InfernalBrick(), 3f, 15f),
    CRUSHED_OBSIDIAN(Module.FACTORY, "crushed.obsidian", new CrushedObsidian(), 2f, 45f),
    SANDY_BRICK(Module.STRUCTURES, "brick.sandy", new SandyBrick(), 2f, 10f),;
//    BANDED_PLANKS(Module.STRUCTURES, "Banded Planks", "planks.banded", new BandedPlanks());
    public static final EnumCube[] VALUES = values();
    private final Module module;
    private final String tag;
    private final CubeClass block;
    private final float hardness;
    private final float resistance;
    private static final List<EnumCube> creativeList = new ArrayList<EnumCube>();

    static {
        creativeList.add(STEEL_BLOCK);
        creativeList.add(CONCRETE_BLOCK);
        creativeList.add(SANDY_BRICK);
        creativeList.add(INFERNAL_BRICK);
        creativeList.add(CRUSHED_OBSIDIAN);
//        creativeList.add(BANDED_PLANKS);
    }

    private EnumCube(Module module, String tag, CubeClass block, float hardness, float resistance) {
        this.module = module;
        this.tag = tag;
        this.block = block;
        this.hardness = hardness;
        this.resistance = resistance;
    }

    public static List<EnumCube> getCreativeList() {
        return creativeList;
    }

    public Module getModule() {
        return module;
    }

    public String getTag() {
        return "rc.cube." + tag;
    }

    public CubeClass getBlock() {
        return block;
    }

    public float getHardness() {
        return hardness;
    }

    public float getResistance() {
        return resistance;
    }

    public boolean isEnabled() {
        return ModuleManager.isModuleLoaded(getModule()) && RailcraftConfig.isSubBlockEnabled(getTag()) && BlockCube.getBlock() != null;
    }

    public static EnumCube fromOrdinal(int id) {
        if (id < 0 || id >= VALUES.length) {
            return VALUES[0];
        }
        return VALUES[id];
    }

    public ItemStack getItem() {
        return getItem(1);
    }

    public ItemStack getItem(int qty) {
        return new ItemStack(BlockCube.getBlock(), qty, ordinal());
    }
}
