package railcraft.common.blocks.detector;

import java.util.List;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import railcraft.common.api.carts.CartTools;
import railcraft.common.gui.EnumGui;
import railcraft.common.gui.GuiHandler;

// Referenced classes of package net.minecraft.src:
//            TileEntity, NBTTagCompound, World
public class TileDetectorAdvanced extends TileDetectorFilter {

    public TileDetectorAdvanced() {
        super(9);
    }

    @Override
    public boolean testForCarts() {
        List<EntityMinecart> carts = CartTools.getMinecartsOnAllSides(worldObj, xCoord, yCoord, zCoord, SENSITIVITY);
        for (EntityMinecart cart : carts) {
            for (ItemStack filter : getFilters()) {
                if (CartTools.doesCartMatchFilter(filter, cart)) {
                    return true;
                }
            }
        }
        return false;
    }

    @Override
    public boolean blockActivated(EntityPlayer player) {
        GuiHandler.openGui(EnumGui.DETECTOR_ADVANCED, player, worldObj, xCoord, yCoord, zCoord);
        return true;
    }
}
