package railcraft.common.blocks.detector;

import net.minecraft.nbt.NBTTagCompound;
import railcraft.common.util.inventory.PhantomInventory;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public abstract class TileDetectorFilter extends TileDetector
{

    private final PhantomInventory invFilters;

    protected TileDetectorFilter(int invSize)
    {
        invFilters = new PhantomInventory(invSize);
    }

    public PhantomInventory getFilters(){
        return invFilters;
    }

    @Override
    public void writeToNBT(NBTTagCompound data)
    {
        super.writeToNBT(data);

        NBTTagCompound filters = new NBTTagCompound();
        getFilters().writeToNBT("Items", filters);
        data.setCompoundTag("filters", filters);
    }

    @Override
    public void readFromNBT(NBTTagCompound data)
    {
        super.readFromNBT(data);

        NBTTagCompound filters = data.getCompoundTag("filters");
        getFilters().readFromNBT("Items", filters);
    }
}
