package railcraft.common.blocks.detector;

import java.util.List;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import railcraft.common.api.carts.CartTools;
import railcraft.common.gui.EnumGui;
import railcraft.common.gui.GuiHandler;

public class TileDetectorSheep extends TileDetectorFilter {

    public TileDetectorSheep() {
        super(1);
    }

    @Override
    public boolean testForCarts() {
        List<EntityMinecart> carts = CartTools.getMinecartsOnAllSides(worldObj, xCoord, yCoord, zCoord, SENSITIVITY);
        for (EntityMinecart cart : carts) {
            if (cart.riddenByEntity instanceof EntitySheep) {
                EntitySheep sheep = (EntitySheep) cart.riddenByEntity;
                ItemStack wool = getFilters().getStackInSlot(0);
                if (!sheep.isChild() && !sheep.getSheared() && (wool == null || sheep.getFleeceColor() == wool.getItemDamage())) {
                    return true;
                }
            }
        }
        return false;
    }

    @Override
    public boolean blockActivated(EntityPlayer player) {
        GuiHandler.openGui(EnumGui.DETECTOR_SHEEP, player, worldObj, xCoord, yCoord, zCoord);
        return true;
    }
}
