package railcraft.common.blocks.machine;

import java.util.List;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import railcraft.common.blocks.machine.alpha.EnumMachineAlpha;
import railcraft.common.carts.ItemCartAnchor;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.lang.RailcraftLanguage;

public class ItemMachine extends ItemBlock {

    public ItemMachine(int i) {
        super(i);
        setMaxDamage(0);
        setHasSubtypes(true);
        setItemName("rc.machine");
    }

    @Override
    public String getTextureFile() {
        return RailcraftConstants.MACHINE_TEXTURE_FILE;
    }

    @Override
    public int getIconFromDamage(int damage) {
        return Block.blocksList[getBlockID()].getBlockTextureFromSideAndMetadata(2, damage);
    }

    @Override
    public int getMetadata(int damage) {
        return damage;
    }

    @Override
    public String getItemNameIS(ItemStack stack) {
        Block block = Block.blocksList[getBlockID()];
        if (block instanceof BlockMachine) {
            return ((BlockMachine) block).getMachineProxy().getTag(stack.getItemDamage());
        }
        return "";
    }

    @Override
    public boolean placeBlockAt(ItemStack stack, EntityPlayer player, World world, int x, int y, int z, int side, float hitX, float hitY, float hitZ, int metadata) {
        if (!world.setBlockAndMetadataWithNotify(x, y, z, getBlockID(), metadata)) {
            return false;
        }

        if (world.getBlockId(x, y, z) == getBlockID()) {
            Block.blocksList[getBlockID()].onBlockPlacedBy(world, x, y, z, player);
            Block.blocksList[getBlockID()].onPostBlockPlaced(world, x, y, z, metadata);
            ((BlockMachine) Block.blocksList[getBlockID()]).initFromItem(world, x, y, z, stack);
        }

        return true;
    }

    @Override
    public void addInformation(ItemStack stack, EntityPlayer player, List info, boolean adv) {
        Block block = Block.blocksList[getBlockID()];
        if (block instanceof BlockMachine) {
            ((BlockMachine) block).getMachineProxy().addItemInfo(stack, player, info, adv);
        }
    }
}
