package railcraft.common.blocks.machine;

import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import railcraft.common.util.inventory.InvTools;
import railcraft.common.util.inventory.StandaloneInventory;

public abstract class TileMachineItem extends TileMachineBase implements IInventory
{

    private StandaloneInventory inv;

    protected TileMachineItem() {
        inv = new StandaloneInventory(0, (IInventory)this);
    }

    protected TileMachineItem(int invSize) {
        inv = new StandaloneInventory(invSize, (IInventory)this);
    }

    protected void setInventorySize(int invSize) {
        this.inv = new StandaloneInventory(invSize, (IInventory)this);
    }

    protected StandaloneInventory getInventory() {
        return inv;
    }

    protected void dropItem(ItemStack stack) {
        InvTools.dropItem(stack, worldObj, xCoord, yCoord, zCoord);
    }

    @Override
    public void openChest() {
    }

    @Override
    public void closeChest() {
    }

    @Override
    public int getSizeInventory() {
        return inv.getSizeInventory();
    }

    @Override
    public ItemStack decrStackSize(int i, int j) {
        return inv.decrStackSize(i, j);
    }

    @Override
    public int getInventoryStackLimit() {
        return inv.getInventoryStackLimit();
    }

    @Override
    public ItemStack getStackInSlot(int i) {
        return inv.getStackInSlot(i);
    }

    @Override
    public void readFromNBT(NBTTagCompound data) {
        super.readFromNBT(data);
        inv.readFromNBT("Items", data);
    }

    @Override
    public void writeToNBT(NBTTagCompound data) {
        super.writeToNBT(data);
        inv.writeToNBT("Items", data);
    }

    @Override
    public void setInventorySlotContents(int i, ItemStack itemstack) {
        inv.setInventorySlotContents(i, itemstack);
    }

    @Override
    public ItemStack getStackInSlotOnClosing(int slot) {
        return null;
    }
}
