package railcraft.common.blocks.machine.alpha;

import net.minecraft.entity.ai.EntityAISit;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.passive.EntityTameable;

public class EntityAISitBred extends EntityAISit
{

    private EntityTameable theEntity;
    private boolean isSitting = false;

    public EntityAISitBred(EntityTameable animal) {
        super(animal);
        this.theEntity = animal;
    }

    /**
     * Returns whether the EntityAIBase should begin execution.
     */
    @Override
    public boolean shouldExecute() {
        if(!this.theEntity.isTamed()) {
            return false;
        } else if(this.theEntity.isInWater()) {
            return false;
        } else if(!this.theEntity.onGround) {
            return false;
        } else {
            EntityLiving owner = theEntity.getOwner();

            if(!theEntity.getOwnerName().equals("") && owner == null) {
                return true;
            }

            if(owner != null && (theEntity.getDistanceSqToEntity(owner) > 144.0D && owner.getAITarget() != null)) {
                return false;
            }

            return isSitting;
        }
    }

    @Override
    public void setSitting(boolean sit) {
        super.setSitting(sit);
        this.isSitting = sit;
    }
}
