package railcraft.common.blocks.machine.alpha;

import java.util.Random;
import net.minecraft.entity.Entity;
import net.minecraft.entity.passive.EntityTameable;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.event.entity.player.EntityInteractEvent;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TamingInteractHandler
{

    private Random rand = new Random();

    @ForgeSubscribe
    public void interact(EntityInteractEvent event) {
        Entity entity = event.target;

        if(entity instanceof EntityTameable) {
            EntityTameable tameable = (EntityTameable)entity;
            if(tameable.isTamed() && tameable.getOwnerName().equals("")) {
                if(rand.nextInt(3) == 0) {
                    tameable.setOwner(event.entityPlayer.username);
                    playTameEffect(tameable, true);
                    tameable.func_70907_r().setSitting(true);
                    tameable.worldObj.setEntityState(tameable, (byte)7);
                } else {
                    playTameEffect(tameable, false);
                    tameable.worldObj.setEntityState(tameable, (byte)6);
                }
                event.setCanceled(true);
            }
        }
    }

    protected void playTameEffect(EntityTameable tameable, boolean par1) {
        String var2 = "heart";

        if(!par1) {
            var2 = "smoke";
        }

        for(int var3 = 0; var3 < 7; ++var3) {
            double var4 = rand.nextGaussian() * 0.02D;
            double var6 = rand.nextGaussian() * 0.02D;
            double var8 = rand.nextGaussian() * 0.02D;
            tameable.worldObj.spawnParticle(var2, tameable.posX + (double)(rand.nextFloat() * tameable.width * 2.0F) - (double)tameable.width, tameable.posY + 0.5D + (double)(rand.nextFloat() * tameable.height), tameable.posZ + (double)(rand.nextFloat() * tameable.width * 2.0F) - (double)tameable.width, var4, var6, var8);
        }
    }
}
