/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.blocks.machine.alpha;

import net.minecraftforge.common.ForgeChunkManager;
import net.minecraftforge.common.ForgeChunkManager.Ticket;
import net.minecraftforge.common.ForgeChunkManager.Type;
import railcraft.common.blocks.machine.IEnumMachine;
import railcraft.common.core.Railcraft;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.util.misc.MiscTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TileAnchorPersonal extends TileAnchorWorld {

    private static final int MINUTES_BEFORE_DISABLE = 5;
    private long ticksSincePlayerLogged;
    
    @Override
    public IEnumMachine getMachineType() {
        return EnumMachineAlpha.PERSONAL_ANCHOR;
    }

    @Override
    protected Ticket getTicketFromForge() {
        return ForgeChunkManager.requestPlayerTicket(Railcraft.getMod(), getOwner(), worldObj, Type.NORMAL);
    }

    @Override
    protected int getRefuelTime() {
        return RailcraftConfig.anchorRefuelPersonal();
    }

    @Override
    protected boolean meetsTicketRequirements() {
        return MiscTools.isPlayerConnected(getOwner()) && super.meetsTicketRequirements();
    }

    @Override
    public void updateEntity() {
        if (ticket != null) {
            if (MiscTools.isPlayerConnected(getOwner())) {
                ticksSincePlayerLogged = 0;
            } else {
                ticksSincePlayerLogged++;
            }
            if (ticksSincePlayerLogged > RailcraftConstants.TICKS_PER_MIN * MINUTES_BEFORE_DISABLE) {
                releaseTicket();
            }
        }
        super.updateEntity();
    }
}
