package railcraft.common.blocks.machine.beta;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.common.ForgeDirection;
import net.minecraftforge.liquids.ILiquidTank;
import net.minecraftforge.liquids.ITankContainer;
import net.minecraftforge.liquids.LiquidStack;
import railcraft.common.liquids.tanks.FakeTank;
import railcraft.common.util.misc.MiscTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public abstract class TileBoilerTank extends TileBoiler {

    private boolean isConnected;

    protected TileBoilerTank() {
        super();
    }

    @Override
    public void writePacketData(DataOutputStream data) throws IOException {
        super.writePacketData(data);

        data.writeBoolean(isStructureValid());
    }

    @Override
    public void readPacketData(DataInputStream data) throws IOException {
        super.readPacketData(data);

        isConnected = data.readBoolean();
    }

    public boolean isConnected() {
        return isConnected;
    }

    @Override
    public int fill(ForgeDirection from, LiquidStack resource, boolean doFill) {
        return 0;
    }

    @Override
    public int fill(int tankIndex, LiquidStack resource, boolean doFill) {
        return 0;
    }

    @Override
    public ITankContainer getOutputOnSide(ForgeDirection side) {
        TileEntity tile = MiscTools.getBlockTileEntityOnSide(worldObj, xCoord, yCoord, zCoord, side);
        if (tile instanceof TileBoiler) {
            return null;
        } else if (tile instanceof ITankContainer) {
            return (ITankContainer) tile;
        }
        return null;
    }

    @Override
    public ILiquidTank getTank(ForgeDirection side, LiquidStack type) {
        TileBoilerFirebox mBlock = (TileBoilerFirebox) getMasterBlock();
        if (mBlock != null) {
            return mBlock.tankManager.getTank(TANK_STEAM);
        }
        return FakeTank.INSTANCE;
    }
}
