package railcraft.common.blocks.machine.beta;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import railcraft.common.api.core.WorldCoordinate;
import railcraft.common.api.core.items.IToolCrowbar;
import railcraft.common.blocks.machine.IEnumMachine;
import railcraft.common.blocks.machine.TileMachineBase;
import railcraft.common.blocks.machine.alpha.TileAnchorWorld;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.util.misc.Game;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TileSentinel extends TileMachineBase {

    @Override
    public IEnumMachine getMachineType() {
        return EnumMachineBeta.SENTINEL;
    }

    @Override
    public int getBlockTexture(int side) {
        return getMachineType().getTexture(side);
    }

    @Override
    public boolean blockActivated(EntityPlayer player, int side) {
        ItemStack current = player.getCurrentEquippedItem();
        if (current != null && current.getItem() instanceof IToolCrowbar) {
            IToolCrowbar crowbar = (IToolCrowbar) current.getItem();
            if (crowbar.canWhack(player, current, xCoord, yCoord, zCoord)) {
                TileAnchorWorld.pairingMap.put(player, new WorldCoordinate(worldObj.provider.dimensionId, xCoord, yCoord, zCoord));
                if (Game.isNotHost(worldObj)) {
                    String message = RailcraftLanguage.translate("gui.anchor.pair.start");
                    player.addChatMessage(String.format(message, getInvName()));
                }
                crowbar.onWhack(player, current, xCoord, yCoord, zCoord);
                return true;
            }
        }
        return super.blockActivated(player, side);
    }

    @Override
    public float getResistance(Entity exploder) {
        return 60f;
    }

    @Override
    public float getHardness() {
        return 20;
    }
}
