package railcraft.common.blocks.machine.beta;

import net.minecraftforge.common.ForgeDirection;
import railcraft.common.blocks.machine.IEnumMachine;
import railcraft.common.util.misc.MiscTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TileTankIronGauge extends TileTankIron
{

    @Override
    public IEnumMachine getMachineType() {
        return EnumMachineBeta.TANK_IRON_GAUGE;
    }

    @Override
    public int getBlockTexture(int side) {
        ForgeDirection s = ForgeDirection.getOrientation(side);
        if(!isStructureValid() || getPattern() == null) {
            return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(side);
        }

        char markerSide = getPattern().getPatternMarkerChecked(MiscTools.getXOnSide(getPatternPositionX(), s), MiscTools.getYOnSide(getPatternPositionY(), s), MiscTools.getZOnSide(getPatternPositionZ(), s));

        if(!isMapPositionOtherBlock(markerSide)) {
            return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(6);
        }

        if(s == ForgeDirection.UP || s == ForgeDirection.DOWN) {
            int markerTop = getPattern().getPatternMarkerChecked(getPatternPositionX(), getPatternPositionY() + 1, getPatternPositionZ());
            if(markerTop == 'A' || markerTop == 'O') {
                int metaUp = worldObj.getBlockMetadata(xCoord, yCoord, zCoord - 1);
                int metaDown = worldObj.getBlockMetadata(xCoord, yCoord, zCoord + 1);

                if(metaUp == getBlockMetadata() && metaDown == getBlockMetadata()) {
                    return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(8);
                } else if(metaUp == getBlockMetadata()) {
                    return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(7);
                } else if(metaDown == getBlockMetadata()) {
                    return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(9);
                }
            }
            return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(0);
        }



        int metaUp = worldObj.getBlockMetadata(xCoord, yCoord + 1, zCoord);
        int metaDown = worldObj.getBlockMetadata(xCoord, yCoord - 1, zCoord);

        if(metaUp == getBlockMetadata() && metaDown == getBlockMetadata()) {
            return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(8);
        } else if(metaUp == getBlockMetadata()) {
            return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(7);
        } else if(metaDown == getBlockMetadata()) {
            return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(9);
        }

        return EnumMachineBeta.TANK_IRON_GAUGE.getTexture(0);
    }
}
