/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package railcraft.common.blocks.ore;

import net.minecraft.item.ItemStack;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.modules.ModuleManager;
import railcraft.common.modules.ModuleManager.Module;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public enum EnumOre
{

    SULFUR(1, "sulfur"),
    SALTPETER(17, "saltpeter");
    private final int texture;
    private final String tag;

    private EnumOre(int texture, String tag)
    {
        this.texture = texture;
        this.tag = tag;
    }

    public ItemStack getItem()
    {
        return getItem(1);
    }

    public String getTag()
    {
        return "rc.ore." + tag;
    }

    public ItemStack getItem(int qty)
    {
        return new ItemStack(BlockOre.getBlock().blockID, qty, ordinal());
    }

    public int getTexture(int side)
    {
        return texture;
    }

    public boolean isEnabled()
    {
        return ModuleManager.isModuleLoaded(Module.WORLD) && BlockOre.getBlock() != null && RailcraftConfig.isSubBlockEnabled(getTag());
    }

    public static EnumOre fromMeta(int meta)
    {
        if(meta < 0 || meta >= values().length) {
            return SULFUR;
        }
        return values()[meta];
    }
}
