package railcraft.common.blocks.ore;

import java.util.List;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.ItemStack;
import railcraft.common.items.ItemRailcraft;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ItemDust extends ItemRailcraft
{

    public enum EnumDust
    {

        OBSIDIAN, SULFUR, SALTPETER, CHARCOAL
    };

    public ItemDust(int id) {
        super(id);
        setHasSubtypes(true);
        setMaxDamage(0);
        setItemName("rc.dust");
    }

    @Override
    public void getSubItems(int id, CreativeTabs tab, List list) {
        for(EnumDust dust : EnumDust.values()) {
            list.add(new ItemStack(this, 1, dust.ordinal()));
        }
    }

    @Override
    public int getIconFromDamage(int damage) {
        if(damage >= EnumDust.values().length) {
            return 0;
        }
        switch (EnumDust.values()[damage]) {
            case OBSIDIAN:
                return 182;
            case SULFUR:
                return 2;
            case SALTPETER:
                return 18;
            case CHARCOAL:
                return 167;
            default:
                return 0;
        }
    }

    @Override
    public String getItemNameIS(ItemStack stack) {
        int damage = stack.getItemDamage();
        if(damage < 0 || damage >= EnumDust.values().length) {
            return "";
        }
        switch (EnumDust.values()[damage]) {
            case OBSIDIAN:
                return "rc.dust.obsidian";
            case SULFUR:
                return "rc.dust.sulfur";
            case SALTPETER:
                return "rc.dust.saltpeter";
            case CHARCOAL:
                return "rc.dust.charcoal";
            default:
                return "";
        }
    }
}
