package railcraft.common.blocks.ore;

import java.util.Random;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;
import net.minecraft.world.gen.feature.WorldGenerator;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.event.terraingen.OreGenEvent;
import net.minecraftforge.event.terraingen.TerrainGen;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class SaltpeterDecorator {

    private WorldGenerator saltpeter = new WorldGenSaltpeter();

    @ForgeSubscribe
    public void generate(OreGenEvent.Post event) {

        World world = event.world;
        Random rand = event.rand;
        int worldX = event.worldX;
        int worldZ = event.worldZ;

        if (!TerrainGen.generateOre(world, rand, saltpeter, worldX, worldZ, OreGenEvent.GenerateMinable.EventType.CUSTOM)) {
            return;
        }

        BiomeGenBase biome = world.getBiomeGenForCoords(worldX + 16, worldZ + 16);
        if (biome != BiomeGenBase.hell && biome.temperature >= 1.5f && biome.rainfall <= 0.1f && !biome.canSpawnLightningBolt()) {
            for (int i = 0; i < 64; i++) {
                int x = worldX + rand.nextInt(16);
                int z = worldZ + rand.nextInt(16);
                int y = world.getTopSolidOrLiquidBlock(x, z) - 1 - (rand.nextInt(100) == 0 ? 0 : 1);
                if (y < 50 || y > 100) {
                    continue;
                }
                saltpeter.generate(world, rand, x, y, z);
            }
        }
    }
}
