package railcraft.common.blocks.ore;

import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.event.terraingen.OreGenEvent;
import net.minecraftforge.event.terraingen.TerrainGen;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class SulfurDecorator {

    private final Set<BiomeGenBase> biomesSulfur = new HashSet<BiomeGenBase>();
    private WorldGenerator sulfur = new WorldGenSulfur();

    public SulfurDecorator() {
        biomesSulfur.add(BiomeGenBase.extremeHills);
        biomesSulfur.add(BiomeGenBase.extremeHillsEdge);
    }

    @ForgeSubscribe
    public void generate(OreGenEvent.Post event) {

        World world = event.world;
        Random rand = event.rand;
        int worldX = event.worldX;
        int worldZ = event.worldZ;
        
        if (!TerrainGen.generateOre(world, rand, sulfur, worldX, worldZ, OreGenEvent.GenerateMinable.EventType.CUSTOM)) {
            return;
        }

        BiomeGenBase biome = world.getBiomeGenForCoords(worldX + 16, worldZ + 16);
        if (biomesSulfur.contains(biome)) {
            for (int i = 0; i < 90; i++) {
                int x = worldX + rand.nextInt(16);
                int y = 6 + rand.nextInt(10);
                int z = worldZ + rand.nextInt(16);

                sulfur.generate(world, rand, x, y, z);
            }
        }
    }
}
