package railcraft.common.blocks.ore;

import net.minecraft.world.gen.feature.*;
import java.util.Random;
import net.minecraft.block.Block;
import net.minecraft.world.World;

public class WorldGenSaltpeter extends WorldGenerator {

    private Random noiseRand = new Random();
    /**
     * The block ID of the ore to be placed using this generator.
     */
    private final int minableBlockId = BlockOre.getBlock().blockID;
    private final int minableBlockMeta = EnumOre.SALTPETER.ordinal();

    public WorldGenSaltpeter() {
    }

    @Override
    public boolean generate(World world, Random rand, int x, int y, int z) {
        if (isReplaceable(world, rand, x, y, z)) {
            world.setBlockAndMetadata(x, y, z, this.minableBlockId, minableBlockMeta);

            Block worldLogic = BlockWorldLogic.getBlock();
            if (worldLogic != null) {
                world.setBlockAndMetadata(x, 0, z, worldLogic.blockID, 0);
            }
        }

        return true;
    }

    private boolean isReplaceable(World world, Random rand, int x, int y, int z) {
        int blockId = world.getBlockId(x, y, z);
        if (blockId != Block.sand.blockID) {
            return false;
        }
        if (SimplexNoise.noise(x * 0.01, z * 0.01) < 0.75) {
            return false;
        }

//        if(world.isAirBlock(x, y + 1, z)){
//            return false;
//        }
        return true;
    }
}
