package railcraft.common.blocks.ore;

import java.util.Random;
import net.minecraft.block.Block;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;
import net.minecraftforge.common.ForgeDirection;
import railcraft.common.util.misc.MiscTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class WorldGenSulfur extends WorldGenerator
{

    private int sulfurId = BlockOre.getBlock().blockID;
    private int sulfurMeta = EnumOre.SULFUR.ordinal();
    private static final int AMOUNT = 10;

    public WorldGenSulfur()
    {
        super();

    }

    @Override
    public boolean generate(World world, Random rand, int x, int y, int z)
    {
        if(nearLava(world, x, y, z)) {
            placeOre(world, rand, x, y, z);
            return true;
        }
        return false;
    }

    private void placeOre(World world, Random rand, int x, int y, int z)
    {
        for(int num = 0; num < AMOUNT; num++) {
            Block block = Block.blocksList[world.getBlockId(x, y, z)];
            if(block != null && block.isGenMineableReplaceable(world, x, y, z)) {
                world.setBlockAndMetadata(x, y, z, sulfurId, sulfurMeta);
            }

            ForgeDirection dir = ForgeDirection.getOrientation(rand.nextInt(6));

            x = MiscTools.getXOnSide(x, dir);
            y = MiscTools.getYOnSide(y, dir);
            z = MiscTools.getZOnSide(z, dir);


            if(!world.blockExists(x, y, z)) {
                break;
            }
        }
    }

    private boolean nearLava(World world, int x, int y, int z)
    {
        for(int side = 2; side < 6; side++) {
            ForgeDirection s = ForgeDirection.getOrientation(side);
            int i = MiscTools.getXOnSide(x, s);
            int j = MiscTools.getYOnSide(y, s);
            int k = MiscTools.getZOnSide(z, s);

            if(world.blockExists(i, j, k)) {
                int id = world.getBlockId(i, j, k);
                if(id == Block.lavaStill.blockID || id == Block.lavaMoving.blockID) {
                    return true;
                }
            }
        }
        for(int j = 0; j < 4; j++) {
            int id = world.getBlockId(x, y - j, z);

            if(id == Block.lavaStill.blockID || id == Block.lavaMoving.blockID) {
                return true;
            } else if(id != 0) {
                return false;
            }
        }
        return false;
    }
}
