package railcraft.common.blocks.signals;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.common.ForgeDirection;
import railcraft.common.blocks.RailcraftBlocks;
import railcraft.common.core.RailcraftConstants;

public class ItemSignal extends ItemBlock {

    public ItemSignal(int id) {
        super(id);
        setMaxDamage(0);
        setHasSubtypes(true);
        setItemName("rcStructureItem");
    }

    public EnumSignal getStructureType(ItemStack stack) {
        return EnumSignal.fromId(stack.getItemDamage());
    }

    @Override
    public int getIconFromDamage(int damage) {
        return RailcraftBlocks.getBlockSignal().getBlockTextureFromSideAndMetadata(2, damage);
    }

    @Override
    public int getMetadata(int damage) {
        return damage;
    }

    @Override
    public String getItemNameIS(ItemStack stack) {
        return getStructureType(stack).getTag();
    }

    @Override
    public String getTextureFile() {
        return RailcraftConstants.MAIN_TEXTURE_FILE;
    }

    @Override
    public boolean canPlaceItemBlockOnSide(World world, int x, int y, int z, int side, EntityPlayer player, ItemStack stack) {
        int oldID = world.getBlockId(x, y, z);

        if (oldID == Block.snow.blockID) {
            side = 1;
        } else if (oldID != Block.vine.blockID && oldID != Block.tallGrass.blockID && oldID != Block.deadBush.blockID
                && (Block.blocksList[oldID] == null || !Block.blocksList[oldID].isBlockReplaceable(world, x, y, z))) {
            if (side == 0) {
                --y;
            }

            if (side == 1) {
                ++y;
            }

            if (side == 2) {
                --z;
            }

            if (side == 3) {
                ++z;
            }

            if (side == 4) {
                --x;
            }

            if (side == 5) {
                ++x;
            }
        }

        return world.canPlaceEntityOnSide(this.getBlockID(), x, y, z, false, side, (Entity) null) && (!getStructureType(stack).needsSupport() || world.isBlockSolidOnSide(x, y - 1, z, ForgeDirection.UP));
    }
}
