/*
 * Copyright (c) CovertJaguar, 2011 http://railcraft.info
 * 
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.blocks.signals;

import railcraft.common.api.core.WorldCoordinate;
import railcraft.common.api.signals.SignalAspect;
import railcraft.common.blocks.RailcraftTileEntity;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class SignalBlockSimple extends SignalBlock {

    private SignalAspect aspect = SignalAspect.BLINK_RED;

    protected SignalBlockSimple(RailcraftTileEntity tile) {
        super(tile, 1);
    }
    
    @Override
    public void updateSignalAspect() {
        aspect = determineAspect(pairings.peek());
    }

    @Override
    public SignalAspect getSignalAspect() {
        return aspect;
    }

    @Override
    protected SignalAspect getSignalAspectForPair(WorldCoordinate otherCoord) {
        return SignalAspect.GREEN;
    }
}
