package railcraft.common.blocks.signals;

import net.minecraft.util.AxisAlignedBB;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.ForgeDirection;
import railcraft.common.blocks.RailcraftBlocks;
import railcraft.common.blocks.RailcraftTileEntity;
import railcraft.common.lang.RailcraftLanguage;

public abstract class TileSignalFoundation extends RailcraftTileEntity {

    public abstract EnumSignal getSignalType();

    public boolean blockActivated(int side, EntityPlayer player) {
        return false;
    }

    public void onBlockPlaced() {
    }

    public void onNeighborBlockChange(int blockId) {
    }

    public void onBlockRemoval(World world, int i, int j, int k) {
    }

    public void setBlockBoundsBasedOnState(IBlockAccess world, int i, int j, int k) {
        RailcraftBlocks.getBlockSignal().setBlockBounds(0, 0, 0, 1, 1, 1);
    }

    public AxisAlignedBB getCollisionBoundingBoxFromPool(World world, int i, int j, int k) {
        return AxisAlignedBB.getAABBPool().addOrModifyAABBInPool(i, j, k, i + 1, j + 1, k + 1);
    }

    public AxisAlignedBB getSelectedBoundingBoxFromPool(World world, int i, int j, int k) {
        return AxisAlignedBB.getAABBPool().addOrModifyAABBInPool(i, j, k, i + 1, j + 1, k + 1);
    }

    public boolean isBlockSolidOnSide(World world, int i, int j, int k, ForgeDirection side) {
        return false;
    }

    public boolean canConnectRedstone(int dir) {
        return false;
    }

    public boolean isPoweringTo(IBlockAccess world, int i, int j, int k, int side) {
        return false;
    }

    @Override
    public Block getBlock() {
        return RailcraftBlocks.getBlockSignal();
    }

    @Override
    public short getId() {
        return (short) getSignalType().ordinal();
    }

    @Override
    public String getInvName() {
        return RailcraftLanguage.translate(getSignalType().getTag());
    }
}
