package railcraft.common.blocks.signals;

import ic2.api.IPaintableBlock;
import ic2.api.IWrenchable;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;
import railcraft.common.blocks.RailcraftBlocks;
import railcraft.common.blocks.aesthetics.post.EnumPost;
import railcraft.common.util.misc.Game;
import railcraft.common.util.misc.SafeNBTWrapper;

@Deprecated
public class TileStructureMetalPost extends TileStructurePost implements IPaintableBlock, IWrenchable {

    private byte color = 0;

    @Override
    public EnumSignal getSignalType() {
        return EnumSignal.METAL_POST;
    }

    @Override
    public void updateEntity() {
        if (Game.isHost(worldObj)) {
            Block blockPost = RailcraftBlocks.getBlockPost();
            if (blockPost != null) {
                if (color == 0) {
                    worldObj.setBlockAndMetadata(xCoord, yCoord, zCoord, blockPost.blockID, EnumPost.METAL.ordinal());
                    return;
                }
            }

            Block blockMetalPost = RailcraftBlocks.getBlockPostMetal();
            if (blockMetalPost != null) {
                if (color != 0) {
                    worldObj.setBlockAndMetadataWithUpdate(xCoord, yCoord, zCoord, blockMetalPost.blockID, color - 1, true);
                    return;
                }
            }

            worldObj.setBlock(xCoord, yCoord, zCoord, 0);
        }
    }

    @Override
    public void writeToNBT(NBTTagCompound data) {
        super.writeToNBT(data);

        data.setByte("Color", color);
    }

    @Override
    public void readFromNBT(NBTTagCompound data) {
        super.readFromNBT(data);
        SafeNBTWrapper safe = new SafeNBTWrapper(data);

        color = safe.getByte("Color");
    }

    @Override
    public void writePacketData(DataOutputStream data) throws IOException {
        super.writePacketData(data);

        data.writeByte(color);
    }

    @Override
    public void readPacketData(DataInputStream data) throws IOException {
        super.readPacketData(data);

        byte c = data.readByte();

        if (color != c) {
            color = c;
            markBlockForUpdate();
        }
    }

    @Override
    public boolean colorBlock(World world, int i, int j, int k, int c) {
        if (color != c + 1) {
            color = (byte) (c + 1);
            return true;
        }
        return false;
    }

    public void setColor(int c) {
        color = (byte) c;
    }

    @Override
    public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, int side) {
        return false;
    }

    @Override
    public void setFacing(short facing) {
    }

    @Override
    public short getFacing() {
        return 0;
    }

    @Override
    public boolean wrenchCanRemove(EntityPlayer entityPlayer) {
        return true;
    }

    @Override
    public float getWrenchDropRate() {
        return 1;
    }

    @Override
    public ItemStack getWrenchDrop(EntityPlayer entityPlayer) {
        return EnumPost.METAL.getItem();
    }

    public byte getColor() {
        return color;
    }
}
