package railcraft.common.blocks.tracks;

import net.minecraft.block.Block;
import net.minecraft.block.BlockFence;
import net.minecraft.block.material.Material;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.IBlockAccess;

public class BlockFenceReplacement extends BlockFence
{

    public BlockFenceReplacement(int i, int j)
    {
        this(i, j, Material.wood);
    }

    public BlockFenceReplacement(int i, int j, Material material)
    {
        super(i, j, material);
        setHardness(2.0F);
        setResistance(5F);
        setStepSound(soundWoodFootstep);
        setBlockName("fence");
    }

    @Override
    public boolean canConnectFenceTo(IBlockAccess iblockaccess, int i, int j, int k)
    {
        int id = iblockaccess.getBlockId(i, j, k);
        if(id == blockID || id == Block.fenceGate.blockID) {
            return true;
        }
        TileEntity tile = iblockaccess.getBlockTileEntity(i, j, k);
        if(tile instanceof TileTrack) {
            if(((TileTrack)tile).getTrackInstance() instanceof TrackGated) {
                return true;
            }
        }
        Block block = Block.blocksList[id];
        if(block != null && block.blockMaterial.isOpaque() && block.renderAsNormalBlock()) {
            return block.blockMaterial != Material.pumpkin;
        }
        return false;
    }
}
