package railcraft.common.blocks.tracks;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import railcraft.common.api.tracks.ITrackInstance;
import railcraft.common.blocks.RailcraftTileEntity;
import railcraft.common.util.misc.Game;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public abstract class TileOldTrack extends RailcraftTileEntity
{

    protected final ITrackInstance track;

    protected TileOldTrack(ITrackInstance t) {
        track = t;
    }

    @Override
    public boolean canUpdate() {
        return true;
    }

    @Override
    public String getInvName() {
        return "";
    }

    @Override
    public void updateEntity() {
        if(Game.isHost(getWorld())) {
            TileEntity tile = new TileTrack(track);
            worldObj.setBlockTileEntity(xCoord, yCoord, zCoord, tile);
        }
    }

    @Override
    public void readFromNBT(NBTTagCompound data) {
        super.readFromNBT(data);

        track.readFromNBT(data);
    }

    @Override
    public short getId() {
        return -1;
    }
}
