package railcraft.common.blocks.tracks;

import net.minecraft.block.Block;
import railcraft.common.api.tracks.TrackInstanceBase;
import railcraft.common.api.tracks.TrackRegistry;
import railcraft.common.api.tracks.TrackSpec;
import railcraft.common.util.misc.Game;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TrackDefault extends TrackInstanceBase
{

    @Override
    public TrackSpec getTrackSpec()
    {
        return TrackRegistry.getTrackSpec(-1);
    }

    @Override
    public int getTextureIndex()
    {
        int meta = tileEntity.getBlockMetadata();
        if(meta >= 6) {
            return getTrackSpec().getTextureIndex() - 16;
        }
        return getTrackSpec().getTextureIndex();
    }

    @Override
    public boolean isFlexibleRail()
    {
        return true;
    }

    @Override
    public boolean canUpdate()
    {
        return true;
    }

    @Override
    public void updateEntity()
    {
        if(Game.isHost(getWorld())) {
            getWorld().setBlockAndMetadataWithNotify(getX(), getY(), getZ(), Block.rail.blockID, tileEntity.getBlockMetadata());
        }
    }
}
