package railcraft.common.blocks.tracks;

import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.World;

public class TrackDisposal extends TrackSuspended {

    private static final int TIME_TILL_NEXT_MOUNT = 40;

    @Override
    public EnumTrack getTrackType() {
        return EnumTrack.DISPOSAL;
    }

    @Override
    public int getTextureIndex() {
        return getTrackSpec().getTextureIndex();
    }

    @Override
    public boolean canMakeSlopes() {
        return false;
    }

    @Override
    public void onMinecartPass(EntityMinecart cart) {
        if (cart.canBeRidden()) {
            if (cart.riddenByEntity instanceof EntityPlayer) {
                cart.riddenByEntity.mountEntity(null);
            } else if (cart.riddenByEntity != null) {
                cart.riddenByEntity.setLocationAndAngles(cart.posX, cart.posY - 2, cart.posZ, cart.riddenByEntity.rotationYaw, cart.riddenByEntity.rotationPitch);
                cart.riddenByEntity.ridingEntity = null;
                cart.riddenByEntity = null;
            }
            cart.getEntityData().setInteger("MountPrevention", TIME_TILL_NEXT_MOUNT);
        }
    }

    @Override
    public boolean canPlaceRailAt(World world, int i, int j, int k) {
        if (world.getBlockId(i, j - 1, k) != 0) {
            return false;
        }
        return super.canPlaceRailAt(world, i, j, k);
    }
}
