package railcraft.common.blocks.tracks;

import net.minecraft.entity.item.EntityMinecart;
import railcraft.common.api.tracks.ITrackLockdown;
import railcraft.common.api.tracks.ITrackPowered;

public class TrackHoldingTrain extends TrackHolding implements ITrackPowered, ITrackLockdown {

    @Override
    public EnumTrack getTrackType() {
        return EnumTrack.HOLDING_TRAIN;
    }

    @Override
    protected byte getDelayTime() {
        return 10;
    }

    @Override
    protected void checkCart(EntityMinecart cart) {
        if (delay > 0) {
            delay = getDelayTime();
            if (cart != getCurrentCart() || reset == 0) {
                setCurrentCart(cart);
                setLaunchDirection(cart);
            }
        }
        reset = 20;
    }
}
