package railcraft.common.carts;

import net.minecraft.block.Block;
import net.minecraft.block.BlockRail;
import net.minecraft.world.World;
import railcraft.common.api.carts.CartBase;
import railcraft.common.core.RailcraftConfig;

public class EntityCartBasic extends CartBase {

    public EntityCartBasic(World world) {
        super(world);
    }

    public EntityCartBasic(World world, double d, double d1, double d2) {
        this(world);
        setPosition(d, d1 + (double) yOffset, d2);
        motionX = 0.0D;
        motionY = 0.0D;
        motionZ = 0.0D;
        prevPosX = d;
        prevPosY = d1;
        prevPosZ = d2;
    }
//
//    @Override
//    public List<ItemStack> getItemsDropped()
//    {
//        List<ItemStack> items = new ArrayList<ItemStack>();
//        if(RailcraftConfig.doCartsBreakOnDrop()) {
//            items.add(MinecraftForge.getItemForCart(EntityMinecart.class, 0));
//            items.add(new ItemStack(Block.chest));
//        } else {
//            items.add(getCartItem());
//        }
//        return items;
//    }

    @Override
    protected double getDrag() {
        if (RailcraftConfig.adjustBasicCartDrag()) {
            return CartConstants.STANDARD_DRAG;
        }
        return super.getDrag();
    }

//    @Override
//    public void onUpdate() {
//        if (Game.isHost(worldObj) && worldObj instanceof WorldServer) {
//            int blockId = worldObj.getBlockId((int) posX, (int) posY, (int) posZ);
//
//            if (blockId == Block.portal.blockID) {
//                setInPortal();
//            }
//
//            if (inPortal) {
//                MinecraftServer mc = ((WorldServer) worldObj).getMinecraftServer();
//                if (mc.getAllowNether()) {
//                    int maxPortalTime = getMaxInPortalTime();
//                    if (ridingEntity == null && field_82153_h++ >= maxPortalTime) {
//                        field_82153_h = maxPortalTime;
//                        timeUntilPortal = getPortalCooldown();
//                        byte dim;
//
//                        if (worldObj.provider.dimensionId == -1) {
//                            dim = 0;
//                        } else {
//                            dim = -1;
//                        }
//
//                        Entity rider = riddenByEntity;
//                        if (rider != null) {
//                            rider.setInPortal();
//                            rider.timeUntilPortal = rider.getPortalCooldown();
//                            rider.travelToDimension(dim);
//                        }
//                        travelToDimension(dim);
//                    }
//
//                    inPortal = false;
//                }
//            }
//        }
//
//        super.onUpdate();
//    }

    @Override
    protected void moveMinecartOnRail(int i, int j, int k) {
        int id = worldObj.getBlockId(i, j, k);
        if (!BlockRail.isRailBlock(id)) {
            return;
        }
        float railMaxSpeed = ((BlockRail) Block.blocksList[id]).getRailMaxSpeed(worldObj, this, i, j, k);

        double maxSpeed = Math.min(railMaxSpeed, getMaxSpeedRail());
        double mX = motionX;
        double mZ = motionZ;
//        if(riddenByEntity != null)
//        {
//            mX *= 0.75D;
//            mZ *= 0.75D;
//        }
        if (mX < -maxSpeed) mX = -maxSpeed;
        if (mX > maxSpeed) mX = maxSpeed;
        if (mZ < -maxSpeed) mZ = -maxSpeed;
        if (mZ > maxSpeed) mZ = maxSpeed;
        moveEntity(mX, 0.0D, mZ);
    }

    @Override
    public boolean isStorageCart() {
        return false;
    }

    @Override
    public boolean canBeRidden() {
        return true;
    }

    @Override
    public int getSizeInventory() {
        return 0;
    }

    @Override
    public String getInvName() {
        return "";
    }
}
