package railcraft.common.carts;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import railcraft.common.api.carts.TransferCartBase;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.util.misc.Game;

public class EntityCartChest extends TransferCartBase {

    public EntityCartChest(World world) {
        super(world);
    }

    public EntityCartChest(World world, double d, double d1, double d2) {
        this(world);
        setPosition(d, d1 + (double) yOffset, d2);
        motionX = 0.0D;
        motionY = 0.0D;
        motionZ = 0.0D;
        prevPosX = d;
        prevPosY = d1;
        prevPosZ = d2;
        minecartType = 1;
    }

    @Override
    public List<ItemStack> getItemsDropped() {
        List<ItemStack> items = new ArrayList<ItemStack>();
        if (RailcraftConfig.doCartsBreakOnDrop()) {
            items.add(new ItemStack(Item.minecartEmpty));
            items.add(new ItemStack(Block.chest));
        } else {
            items.add(getCartItem());
        }
        return items;
    }

    @Override
    public ItemStack getCartItem() {
        return new ItemStack(Item.minecartCrate);
    }

    @Override
    protected double getDrag() {
        return CartConstants.STANDARD_DRAG;
    }

    @Override
    public boolean doInteract(EntityPlayer player) {
        if (Game.isHost(worldObj)) {
            player.displayGUIChest(this);
        }
        return true;
    }

    @Override
    public boolean isStorageCart() {
        return true;
    }

    @Override
    public boolean canBeRidden() {
        return false;
    }

    @Override
    public int getSizeInventory() {
        return 27;
    }

    @Override
    public String getInvName() {
        return "Chest Cart";
    }
}
