package railcraft.common.carts;

import java.util.ArrayList;
import java.util.List;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import railcraft.common.api.carts.CartBase;
import railcraft.common.api.carts.ICartRenderInterface;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.gui.EnumGui;
import railcraft.common.gui.GuiHandler;
import railcraft.common.util.misc.Game;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class EntityCartWork extends CartBase implements ICartRenderInterface
{

    public EntityCartWork(World world)
    {
        super(world);
    }

    public EntityCartWork(World world, double d, double d1, double d2)
    {
        this(world);
        setPosition(d, d1 + (double)yOffset, d2);
        motionX = 0.0D;
        motionY = 0.0D;
        motionZ = 0.0D;
        prevPosX = d;
        prevPosY = d1;
        prevPosZ = d2;
    }

    @Override
    public List<ItemStack> getItemsDropped()
    {
        List<ItemStack> items = new ArrayList<ItemStack>();
        if(RailcraftConfig.doCartsBreakOnDrop()) {
            items.add(new ItemStack(Item.minecartEmpty));
            items.add(new ItemStack(Block.workbench));
        } else {
            items.add(getCartItem());
        }
        return items;
    }

    @Override
    protected double getDrag()
    {
        return CartConstants.STANDARD_DRAG;
    }

    @Override
    public boolean doInteract(EntityPlayer entityplayer)
    {
        if(Game.isHost(getWorld())) {
            GuiHandler.openGui(EnumGui.CART_WORK, entityplayer, worldObj, this);
        }
        return true;
    }

    @Override
    public boolean isStorageCart()
    {
        return false;
    }

    @Override
    public boolean canBeRidden()
    {
        return false;
    }

    @Override
    public int getSizeInventory()
    {
        return 0;
    }

    @Override
    public String getInvName()
    {
        return "Work Cart";
    }

    @Override
    public Block getBlock()
    {
        return Block.workbench;
    }

    @Override
    public int getBlockMetadata()
    {
        return 0;
    }
}
