/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.carts;

import java.util.List;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ItemCartAnchor extends ItemCart {

    public ItemCartAnchor(int i, EnumCart cartType) {
        super(i, cartType);
    }

    public static long getFuel(ItemStack cart) {
        long fuel = 0;
        NBTTagCompound nbt = cart.getTagCompound();
        if (nbt != null) {
            fuel = nbt.getLong("fuel");
        }
        return fuel;
    }

    @Override
    public void addInformation(ItemStack stack, EntityPlayer player, List info, boolean adv) {
        if ((getCartType() == EnumCart.ANCHOR && RailcraftConfig.anchorRefuel() > 0) || (getCartType() == EnumCart.ANCHOR_PERSONAL && RailcraftConfig.anchorRefuelPersonal() > 0)) {
            long fuel = getFuel(stack);
            double hours = (double) fuel / RailcraftConstants.TICKS_PER_HOUR;
            String format = RailcraftLanguage.translate("gui.anchor.fuel.remaining");
            info.add(String.format(format, hours));
        }
    }
}
