package railcraft.common.gui;

/**
 *
 * @author CovertJaguar
 */
public enum EnumGui
{
    LOADER_ITEM(true),
    LOADER_LIQUID(true),
    LOADER_ENERGY(true),
    UNLOADER_LIQUID(true),
    UNLOADER_ENERGY(true),
    DETECTOR_CART(true),
    DETECTOR_ITEM(true),
    DETECTOR_TANK(true),
    DETECTOR_ANIMAL(false),
    DETECTOR_SHEEP(true),
    DETECTOR_ADVANCED(true),
    DETECTOR_TRAIN(false),
    DETECTOR_VILLAGER(false),
    DETECTOR_LOCOMOTIVE(true),
    COKE_OVEN(true),
    STEAN_OVEN(true),
    BLAST_FURNACE(true),
    TANK(true),
    ROCK_CRUSHER(true),
    ROLLING_MACHINE(true),
    CART_DISPENSER(true),
    TRAIN_DISPENSER(true),
    FEED_STATION(true),
    WORLD_ANCHOR(true),
    TRACK_PRIMING(false),
    TRACK_LAUNCHER(false),
    TRACK_EMBARKING(false),
    CART_BORE(true),
    CART_TNT_FUSE(false),
    CART_TNT_BLAST(false),
    CART_WORK(true),
    CART_ENERGY(true),
    CART_TANK(true),
    CART_ANCHOR(true),
    CART_TRACK_RELAYER(true),
    CART_UNDERCUTTER(true),
    LOCO_STEAM(true),
    BOX_CONTROLLER(false),
    BOX_RECEIVER(false),
    BOX_CAPACITOR(false),
    BOX_RELAY(false),
    SWITCH_MOTOR(false),
    ENGINE_HOBBY(true),
    ENGINE_STEAM(true),
    BOILER_SOLID(true),
    BOILER_LIQUID(true),
    TURBINE(true);
    private final byte id;
    private final boolean hasContainer;
    private static byte nextId = 0;

    private EnumGui(boolean hasContainer)
    {
        id = getNextId();
        this.hasContainer = hasContainer;
    }

    public byte getId()
    {
        return id;
    }

    private static byte getNextId()
    {
        return nextId++;
    }

    public boolean hasContainer()
    {
        return hasContainer;
    }

    public static EnumGui fromId(int i)
    {
        for(EnumGui e : values()) {
            if(e.getId() == i) {
                return e;
            }
        }
        return LOADER_ITEM;
    }
}
