package railcraft.common.gui.containers;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import railcraft.common.blocks.detector.TileDetectorAdvanced;
import railcraft.common.gui.slots.SlotMinecartFilter;

public class ContainerDetectorAdvanced extends RailcraftContainer {

    public TileDetectorAdvanced tile;
    private Slot filterSlots;

    public ContainerDetectorAdvanced(InventoryPlayer inventoryplayer, TileDetectorAdvanced tile) {
        super(tile.getFilters());
        this.tile = tile;

        for (int i = 0; i < tile.getFilters().getSizeInventory(); i++) {
            addSlot(filterSlots = new SlotMinecartFilter(tile.getFilters(), i, 8 + i * 18, 24));
        }

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 58 + i * 18));
            }

        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 116));
        }
    }

    @Override
    public boolean canInteractWith(EntityPlayer entityplayer) {
        return tile.isUseableByPlayer(entityplayer);
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack itemstack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if (i >= 9 && i < 36) {
//                if (!mergeItemStack(itemstack1, 36, 45, false)) {
//                    return null;
//                }
//            } else if (i >= 36 && i < 45) {
//                if (!mergeItemStack(itemstack1, 9, 36, false)) {
//                    return null;
//                }
//            }
//            if (itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
