package railcraft.common.gui.containers;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import railcraft.common.blocks.detector.TileDetectorItem;
import railcraft.common.gui.slots.SlotFilter;

public class ContainerDetectorItem extends RailcraftContainer {

    public TileDetectorItem tile;

    public ContainerDetectorItem(InventoryPlayer playerInv, TileDetectorItem tile) {
        super(tile.getFilters());
        this.tile = tile;

        for (int i = 0; i < 9; i++) {
            addSlot(new SlotFilter(tile.getFilters(), i, 8 + i * 18, 61, tile.getSlotController()));
        }

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(playerInv, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
            }
        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(playerInv, j, 8 + j * 18, 142));
        }
    }

    @Override
    public boolean canInteractWith(EntityPlayer entityplayer) {
        return tile.isUseableByPlayer(entityplayer);
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack itemstack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if (i < 9) {
//                return null;
//            } else if (i >= 9 && i < 36) {
//                if (!mergeItemStack(itemstack1, 36, 45, false)) {
//                    return null;
//                }
//            } else if (!mergeItemStack(itemstack1, 9, 36, false)) {
//                return null;
//            }
//            if (itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
