package railcraft.common.gui.containers;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.inventory.Slot;
import railcraft.common.blocks.machine.gamma.TileDispenserTrain;
import railcraft.common.gui.slots.SlotDispenserTrain;
import railcraft.common.gui.slots.SlotMinecart;

public class ContainerDispenserTrain extends RailcraftContainer {

    public TileDispenserTrain tile;
    private Slot minecart;

    public ContainerDispenserTrain(InventoryPlayer playerInv, TileDispenserTrain tile) {
        super(tile);
        this.tile = tile;

        for (int i = 0; i < 9; i++) {
            addSlot(new SlotDispenserTrain(tile.getPattern(), i, 8 + i * 18, 31));
        }

        for (int i = 0; i < 2; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(minecart = new SlotMinecart(tile, k + i * 9, 8 + k * 18, 67 + i * 18));
            }
        }

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(playerInv, k + i * 9 + 9, 8 + k * 18, 111 + i * 18));
            }
        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(playerInv, j, 8 + j * 18, 169));
        }
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack startStack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack moveStack = slot.getStack();
//            startStack = moveStack.copy();
//            if ((i < 9 || i >= 27) && minecart.isItemValid(moveStack)) {
//                mergeItemStack(moveStack, 9, 27, false);
//            }
//            if (moveStack.stackSize == startStack.stackSize) {
//                if (i >= 27 && i < 54) {
//                    if (!mergeItemStack(moveStack, 54, 63, false)) {
//                        return null;
//                    }
//                } else if (i < 27) {
//                    if (!mergeItemStack(moveStack, 27, 63, false)) {
//                        return null;
//                    }
//                } else if (i >= 54) {
//                    if (!mergeItemStack(moveStack, 27, 54, false)) {
//                        return null;
//                    }
//                }
//            }
//
//            if (moveStack.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (moveStack.stackSize != startStack.stackSize) {
//                slot.onPickupFromSlot(player, moveStack);
//            } else {
//                return null;
//            }
//        }
//        return startStack;
//    }
}
