package railcraft.common.gui.containers;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import railcraft.common.gui.slots.SlotEnergy;
import railcraft.common.gui.slots.SlotUpgrade;
import railcraft.common.util.misc.IEnergyDevice;

public class ContainerEnergyLoader extends RailcraftContainer {

    private IEnergyDevice device;

    public ContainerEnergyLoader(InventoryPlayer inventoryplayer, IEnergyDevice device) {
        super(device);
        this.device = device;
        addSlot(new SlotEnergy(device, 0, 8, 17));
        addSlot(new SlotEnergy(device, 1, 8, 53));

        addSlot(new SlotUpgrade(device, 2, 152, 8));
        addSlot(new SlotUpgrade(device, 3, 152, 26));
        addSlot(new SlotUpgrade(device, 4, 152, 44));
        addSlot(new SlotUpgrade(device, 5, 152, 62));

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
            }

        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 142));
        }
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack itemstack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if (i >= 6 && i < 42 && SlotEnergy.canPlaceItem(itemstack1)) {
//                if (!mergeItemStack(itemstack1, 0, 2, false)) {
//                    return null;
//                }
//            } else if (i >= 6 && i < 42 && SlotUpgrade.canPlaceItem(itemstack1)) {
//                if (!mergeItemStack(itemstack1, 2, 6, false)) {
//                    return null;
//                }
//            } else if (i >= 6 && i < 33) {
//                if (!mergeItemStack(itemstack1, 33, 42, false)) {
//                    return null;
//                }
//            } else if (i >= 33 && i < 42) {
//                if (!mergeItemStack(itemstack1, 6, 33, false)) {
//                    return null;
//                }
//            } else if (!mergeItemStack(itemstack1, 6, 42, false)) {
//                return null;
//            }
//            if (itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
