package railcraft.common.gui.containers;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import railcraft.common.blocks.machine.gamma.TileLoaderItemBase;
import railcraft.common.gui.slots.SlotFilter;
import railcraft.common.gui.slots.SlotMinecartFilter;

public class ContainerItemLoader extends RailcraftContainer {

    public TileLoaderItemBase tile;

    public ContainerItemLoader(InventoryPlayer inventoryplayer, TileLoaderItemBase tile) {
        super(tile);
        this.tile = tile;

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 3; k++) {
                addSlot(new SlotFilter(tile.getItemFilters(), k + i * 3, 8 + k * 18, 26 + i * 18));
            }
        }

        addSlot(new SlotMinecartFilter(tile.getCartFilters(), 0, 71, 26));
        addSlot(new SlotMinecartFilter(tile.getCartFilters(), 1, 89, 26));

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 3; k++) {
                addSlot(tile.getBufferSlot(k + i * 3, 116 + k * 18, 26 + i * 18));
            }
        }

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
            }
        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 142));
        }
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack itemstack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if (i >= 11 && i < 20) {
//                if (!mergeItemStack(itemstack1, 20, 56, false)) {
//                    return null;
//                }
//            } else if (i >= 47 && i < 56) {
//                if (!mergeItemStack(itemstack1, 11, 47, false)) {
//                    return null;
//                }
//            } else if (tile instanceof TileItemLoader && mergeItemStack(itemstack1, 11, 20, false)) {
//            } else if (!mergeItemStack(itemstack1, 47, 56, false)) {
//                return null;
//            }
//            if (itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
