package railcraft.common.gui.containers;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import railcraft.common.blocks.machine.gamma.TileLiquidLoader;
import railcraft.common.gui.slots.SlotLiquidContainerFilled;
import railcraft.common.gui.slots.SlotMinecartFilter;
import railcraft.common.gui.slots.SlotOutput;
import railcraft.common.liquids.LiquidGauge;

public class ContainerLiquidLoader extends RailcraftContainer {

    private TileLiquidLoader tile;
    private Slot input;
    private Slot output;

    public ContainerLiquidLoader(InventoryPlayer inventoryplayer, TileLiquidLoader tile) {
        super(tile);
        this.tile = tile;

        addGauge(new LiquidGauge(tile.getTanks(null)[0], 17, 23, 16, 47));

        addSlot(new SlotMinecartFilter(tile.getCartFilters(), 0, 45, 21));
        addSlot(new SlotMinecartFilter(tile.getCartFilters(), 1, 63, 21));
        addSlot(input = new SlotLiquidContainerFilled(tile, 0, 134, 21));
        addSlot(output = new SlotOutput(tile, 1, 134, 56));
        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
            }

        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 142));
        }
    }

    @Override
    public void detectAndSendChanges() {
        super.detectAndSendChanges();
        tile.getTankManager().updateGuiData(this, crafters, 0);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void updateProgressBar(int id, int data) {
        tile.getTankManager().processGuiUpdate(id, data);
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack startStack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack moveStack = slot.getStack();
//            startStack = moveStack.copy();
//            if (i >= 4 && input.isItemValid(moveStack)) {
//                if (!mergeItemStack(moveStack, 2, 3, false)) {
//                    return null;
//                }
//            } else if (i >= 4 && i < 31) {
//                if (!mergeItemStack(moveStack, 31, 40, false)) {
//                    return null;
//                }
//            } else if (i >= 31 && i < 40) {
//                if (!mergeItemStack(moveStack, 4, 31, false)) {
//                    return null;
//                }
//            } else if (!mergeItemStack(moveStack, 4, 40, false)) {
//                return null;
//            }
//            if (moveStack.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (moveStack.stackSize != startStack.stackSize) {
//                slot.onPickupFromSlot(player, moveStack);
//            } else {
//                return null;
//            }
//        }
//        return startStack;
//    }
}
