package railcraft.common.gui.containers;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import railcraft.common.blocks.machine.gamma.TileLiquidUnloader;
import railcraft.common.gui.slots.SlotLiquidContainerEmpty;
import railcraft.common.gui.slots.SlotLiquidFilter;
import railcraft.common.gui.slots.SlotMinecartFilter;
import railcraft.common.gui.slots.SlotOutput;
import railcraft.common.liquids.LiquidGauge;

public class ContainerLiquidUnloader extends RailcraftContainer {

    private TileLiquidUnloader tile;
    private Slot input;

    public ContainerLiquidUnloader(InventoryPlayer inventoryplayer, TileLiquidUnloader tile) {
        super(tile);
        this.tile = tile;

        addGauge(new LiquidGauge(tile.getTanks(null)[0], 17, 23, 16, 47));

        addSlot(new SlotLiquidFilter(tile.getLiquidFilter(), 0, 53, 39));
        addSlot(new SlotMinecartFilter(tile.getCartFilters(), 0, 89, 29));
        addSlot(new SlotMinecartFilter(tile.getCartFilters(), 1, 89, 47));
        addSlot(input = new SlotLiquidContainerEmpty(tile, 0, 134, 21));
        addSlot(new SlotOutput(tile, 1, 134, 56));

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
            }
        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 142));
        }
    }

    @Override
    public void detectAndSendChanges() {
        super.detectAndSendChanges();
        tile.getTankManager().updateGuiData(this, crafters, 0);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void updateProgressBar(int id, int data) {
        tile.getTankManager().processGuiUpdate(id, data);
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack itemstack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if (i >= 5 && input.isItemValid(itemstack1)) {
//                if (!mergeItemStack(itemstack1, 4, 5, false)) {
//                    return null;
//                }
//            } else if (i >= 5 && i < 32) {
//                if (!mergeItemStack(itemstack1, 32, 41, false)) {
//                    return null;
//                }
//            } else if (i >= 32 && i < 41) {
//                if (!mergeItemStack(itemstack1, 5, 32, false)) {
//                    return null;
//                }
//            } else if (!mergeItemStack(itemstack1, 5, 41, false)) {
//                return null;
//            }
//            if (itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
