package railcraft.common.gui.containers;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import railcraft.common.carts.EntityCartTank;
import railcraft.common.gui.slots.SlotLiquidContainer;
import railcraft.common.gui.slots.SlotLiquidFilter;
import railcraft.common.gui.slots.SlotOutput;
import railcraft.common.liquids.LiquidGauge;

public class ContainerTankCart extends RailcraftContainer {

    private EntityCartTank tank;
    private final Slot input;

    public ContainerTankCart(InventoryPlayer inventoryplayer, EntityCartTank cart) {
        super(cart);
        this.tank = cart;

        addGauge(new LiquidGauge(cart.getTanks(null)[0], 35, 23, 16, 47));

        addSlot(new SlotLiquidFilter(cart.getFilter(), 0, 71, 39));
        addSlot(input = new SlotLiquidContainer(cart.getInvBucket(), 0, 116, 21));
        addSlot(new SlotOutput(cart.getInvBucket(), 1, 116, 56));

        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
            }
        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 142));
        }
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack itemstack = null;
//        Slot slot = (Slot) inventorySlots.get(i);
//        if (slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if (i >= 3 && i < 39 && input.isItemValid(itemstack1)) {
//                if (!mergeItemStack(itemstack1, 1, 2, false)) {
//                    return null;
//                }
//            } else if (i >= 3 && i < 30) {
//                if (!mergeItemStack(itemstack1, 30, 39, false)) {
//                    return null;
//                }
//            } else if (i >= 30 && i < 39) {
//                if (!mergeItemStack(itemstack1, 3, 30, false)) {
//                    return null;
//                }
//            } else if (!mergeItemStack(itemstack1, 3, 39, false)) {
//                return null;
//            }
//            if (itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if (itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
