package railcraft.common.gui.containers;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ICrafting;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.inventory.Slot;
import railcraft.common.blocks.machine.alpha.TileSteamTurbine;
import railcraft.common.gui.slots.SlotTurbine;

public class ContainerTurbine extends RailcraftContainer
{

    public TileSteamTurbine tile;
    private Slot rotor;
    private int lastOutput;

    public ContainerTurbine(InventoryPlayer inventoryplayer, TileSteamTurbine tile) {
        super(tile.getInventory());
        this.tile = tile;
        addSlot(rotor = new SlotTurbine(tile.getInventory(), 0, 60, 24));
        for(int i = 0; i < 3; i++) {
            for(int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 58 + i * 18));
            }

        }

        for(int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 116));
        }
    }

    @Override
    public void detectAndSendChanges() {
        super.detectAndSendChanges();
        for(int i = 0; i < crafters.size(); i++) {
            ICrafting icrafting = (ICrafting)crafters.get(i);

            if(lastOutput != Math.round(tile.output)) {
                icrafting.sendProgressBarUpdate(this, 0, Math.round(tile.output));
            }
        }
        lastOutput = Math.round(tile.output);
    }

    @Override
    public void addCraftingToCrafters(ICrafting icrafting) {
        super.addCraftingToCrafters(icrafting);
        icrafting.sendProgressBarUpdate(this, 0, Math.round(tile.output));
    }

    @Override
    public void updateProgressBar(int id, int data) {
        switch (id) {
            case 0:
                tile.output = data;
                break;
        }
    }

//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i) {
//        ItemStack itemstack = null;
//        Slot slot = (Slot)inventorySlots.get(i);
//        if(slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if(i >= 1 && rotor.isItemValid(itemstack1)) {
//                if(!mergeItemStack(itemstack1, 0, 1, false)) {
//                    return null;
//                }
//            } else if(i >= 1 && i < 28) {
//                if(!mergeItemStack(itemstack1, 28, 37, false)) {
//                    return null;
//                }
//            } else if(i >= 28 && i < 37) {
//                if(!mergeItemStack(itemstack1, 1, 28, false)) {
//                    return null;
//                }
//            } else if(!mergeItemStack(itemstack1, 1, 37, false)) {
//                return null;
//            }
//            if(itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if(itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
