package railcraft.common.gui.containers;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import railcraft.common.carts.EntityCartUndercutter;
import railcraft.common.gui.slots.SlotBlockFilter;
import railcraft.common.gui.slots.SlotCopy;
import railcraft.common.gui.slots.SlotUndercutterFilter;

public class ContainerUndercutter extends RailcraftContainer {

    private EntityCartUndercutter cart;
    private Slot under;
    private Slot side;

    public ContainerUndercutter(InventoryPlayer inventoryplayer, EntityCartUndercutter cart) {
        super(cart);
        this.cart = cart;
        
        addSlot(new SlotBlockFilter(cart.getPattern(), 0, 17, 45));
        addSlot(new SlotBlockFilter(cart.getPattern(), 1, 35, 45));
        addSlot(new SlotBlockFilter(cart.getPattern(), 2, 17, 87));
        addSlot(new SlotBlockFilter(cart.getPattern(), 3, 35, 87));
        addSlot(under = new SlotUndercutterFilter(cart.getPattern(), 4, 80, 45));
        addSlot(side = new SlotUndercutterFilter(cart.getPattern(), 5, 80, 87));
        addSlot(new SlotCopy(cart, 0, 131, 45, under));
        addSlot(new SlotCopy(cart, 1, 131, 87, side));
        
        for (int i = 0; i < 3; i++) {
            for (int k = 0; k < 9; k++) {
                addSlot(new Slot(inventoryplayer, k + i * 9 + 9, 8 + k * 18, 123 + i * 18));
            }

        }

        for (int j = 0; j < 9; j++) {
            addSlot(new Slot(inventoryplayer, j, 8 + j * 18, 181));
        }
    }
//    @Override
//    public ItemStack transferStackInSlot(EntityPlayer player, int i)
//    {
//        ItemStack itemstack = null;
//        Slot slot = (Slot)inventorySlots.get(i);
//        if(slot != null && slot.getHasStack()) {
//            ItemStack itemstack1 = slot.getStack();
//            itemstack = itemstack1.copy();
//            if(i >= 4 && i < 40 && copySlot.isItemValid(itemstack1)) {
//                if(!mergeItemStack(itemstack1, 3, 4, false)) {
//                    return null;
//                }
//            } else if(i >= 4 && i < 31) {
//                if(!mergeItemStack(itemstack1, 31, 40, false)) {
//                    return null;
//                }
//            } else if(i >= 31 && i < 40) {
//                if(!mergeItemStack(itemstack1, 4, 31, false)) {
//                    return null;
//                }
//            } else if(!mergeItemStack(itemstack1, 4, 40, false)) {
//                return null;
//            }
//            if(itemstack1.stackSize == 0) {
//                slot.putStack(null);
//            } else {
//                slot.onSlotChanged();
//            }
//            if(itemstack1.stackSize != itemstack.stackSize) {
//                slot.onPickupFromSlot(player, itemstack1);
//            } else {
//                return null;
//            }
//        }
//        return itemstack;
//    }
}
