package railcraft.common.gui.slots;

import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.inventory.Slot;
import railcraft.common.api.crafting.RailcraftCraftingManager;
import railcraft.common.util.inventory.InvTools;

public class SlotCokeOven extends Slot {

    public SlotCokeOven(IInventory iinventory, int slotIndex, int posX, int posY) {
        super(iinventory, slotIndex, posX, posY);
    }

    @Override
    public int getSlotStackLimit() {
        return 64;
    }

    @Override
    public boolean isItemValid(ItemStack stack) {
        return canPlaceItem(stack);
    }

    public static boolean canPlaceItem(ItemStack stack) {
        if (stack != null && !InvTools.isSynthetic(stack) && RailcraftCraftingManager.cokeOven.getRecipe(stack.itemID, stack.getItemDamage()) != null) {
            return true;
        }
        return false;
    }
}
