/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.items;

import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.IArmorTextureProvider;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.util.inventory.InvTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ItemOveralls extends ItemArmor implements IArmorTextureProvider {

    private static ItemStack BLUE_CLOTH = new ItemStack(Block.cloth, 1, 3);
    private static final String TEXTURE = RailcraftConstants.ARMOR_TEXTURE_FOLDER + "overalls.png";

    public static boolean isPlayerWearing(EntityPlayer player) {
        ItemStack pants = player.getCurrentItemOrArmor(2);
        return pants != null && pants.getItem() instanceof ItemOveralls;
    }

    public ItemOveralls(int id) {
        super(id, ItemMaterials.OVERALLS, 0, 2);
        setTextureFile(RailcraftConstants.MAIN_TEXTURE_FILE);
        setIconIndex(11);
    }

    @Override
    public String getArmorTextureFile(ItemStack itemstack) {
        return TEXTURE;
    }

    @Override
    public boolean getIsRepairable(ItemStack itemToRepair, ItemStack stack) {
        return InvTools.isItemEqual(stack, BLUE_CLOTH);
    }
}
