/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.items;

import ic2.api.IMetalArmor;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.IArmorTextureProvider;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.util.misc.MiscTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ItemSteelArmor extends ItemArmor implements IArmorTextureProvider, IMetalArmor {

    private static final String TEXTURE_1 = RailcraftConstants.ARMOR_TEXTURE_FOLDER + "steel_1.png";
    private static final String TEXTURE_2 = RailcraftConstants.ARMOR_TEXTURE_FOLDER + "steel_2.png";

    public ItemSteelArmor(int id, int type) {
        super(id, ItemMaterials.STEEL_ARMOR, 0, type);
        setTextureFile(RailcraftConstants.MAIN_TEXTURE_FILE);
    }

    @Override
    public String getArmorTextureFile(ItemStack itemstack) {
        if (armorType == 2) {
            return TEXTURE_2;
        }
        return TEXTURE_1;
    }

    @Override
    public boolean getIsRepairable(ItemStack itemToRepair, ItemStack stack) {
        return MiscTools.isOreClass(stack, "ingotSteel");
    }

    @Override
    public boolean isMetalArmor(ItemStack itemstack, EntityPlayer player) {
        return true;
    }
}
