package railcraft.common.items;

import net.minecraft.item.ItemStack;
import railcraft.common.api.core.items.ItemRegistry;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.plugins.forge.CraftingPlugin;

public class ItemWhistleTuner extends ItemRailcraft {

    private static ItemWhistleTuner item;

    public static void registerItem() {
        if (item == null) {
            String tag = "rc.tool.whistle.tuner";
            int id = RailcraftConfig.getItemId(tag);

            if (id > 0) {
                item = new ItemWhistleTuner(id);
                item.setItemName(tag);
                RailcraftLanguage.getInstance().registerItemName(item, tag);

                CraftingPlugin.addShapedOreRecipe(new ItemStack(item), true,
                        "N N",
                        "NNN",
                        " N ",
                        'N', "nuggetSteel");

                ItemRegistry.registerItem(tag, new ItemStack(item));
            }
        }
    }

    public static ItemStack getItem() {
        if (item == null) {
            return null;
        }
        return new ItemStack(item);
    }

    public ItemWhistleTuner(int id) {
        super(id);
        setMaxDamage(250);
        setIconIndex(25);
    }
}
