package railcraft.common.liquids;

import forestry.api.recipes.RecipeManagers;
import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.liquids.LiquidContainerData;
import railcraft.common.plugins.forestry.ForestryPlugin;
import railcraft.common.plugins.ic2.IC2Plugin;
import railcraft.common.util.inventory.InvTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ForestryLiquidAdapater implements ILiquidAdaptor {

    public final ItemStack cellEmpty;
    public final ItemStack canEmpty;
    public final ItemStack waxCapsule;
    public final ItemStack refractoryEmpty;
    public final ItemStack refractoryWax;
    public final ItemStack ingotTin;
    public final ItemStack beeswax;
    private static ForestryLiquidAdapater instance;

    public static ForestryLiquidAdapater getInstance() {
        if (instance == null) {
            instance = new ForestryLiquidAdapater();
        }
        return instance;
    }

    private ForestryLiquidAdapater() {
        cellEmpty = IC2Plugin.getItem("cell");
        canEmpty = ForestryPlugin.getItem("canEmpty");
        waxCapsule = ForestryPlugin.getItem("waxCapsule");
        refractoryEmpty = ForestryPlugin.getItem("refractoryEmpty");
        refractoryWax = ForestryPlugin.getItem("refractoryWax");
        ingotTin = ForestryPlugin.getItem("ingotTin");
        beeswax = ForestryPlugin.getItem("beeswax");
    }

    @Override
    public void registerContainer(LiquidContainerData container) {
        if (RecipeManagers.bottlerManager != null) {
            RecipeManagers.bottlerManager.addRecipe(5, container.stillLiquid, container.container, container.filled);
        }

        ItemStack recycle;
        int chance;
        if (InvTools.isItemEqual(container.container, cellEmpty)) {
            recycle = ingotTin;
            chance = 5;
        } else if (InvTools.isItemEqual(container.container, canEmpty)) {
            recycle = ingotTin;
            chance = 5;
        } else if (InvTools.isItemEqual(container.container, waxCapsule)) {
            recycle = beeswax;
            chance = 10;
        } else if (InvTools.isItemEqual(container.container, refractoryEmpty)) {
            recycle = refractoryWax;
            chance = 10;
        } else if (container.container.itemID == Item.glassBottle.itemID) {
            recycle = new ItemStack(Block.glass);
            chance = 10;
        } else {
            return;
        }

        if (RecipeManagers.squeezerManager != null && container.container.itemID != Item.bucketEmpty.itemID) {
            if (recycle != null) {
                RecipeManagers.squeezerManager.addRecipe(10, new ItemStack[]{container.filled}, container.stillLiquid, recycle, chance);
            } else {
                RecipeManagers.squeezerManager.addRecipe(10, new ItemStack[]{container.filled}, container.stillLiquid);
            }
        }
    }
}
