/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.liquids;

import net.minecraftforge.liquids.ILiquidTank;
import net.minecraftforge.liquids.LiquidStack;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ImmutableTankWrapper extends TankWrapper {

    public ImmutableTankWrapper(ILiquidTank tank) {
        super(tank);
    }

    @Override
    public LiquidStack getLiquid() {
        if(tank.getLiquid() == null) return null;
        return tank.getLiquid().copy();
    }

    @Override
    public int getCapacity() {
        return tank.getCapacity();
    }

    @Override
    public int fill(LiquidStack resource, boolean doFill) {
        return tank.fill(resource, false);
    }

    @Override
    public LiquidStack drain(int maxDrain, boolean doDrain) {
        return tank.drain(maxDrain, false);
    }

    @Override
    public int getTankPressure() {
        return tank.getTankPressure();
    }
}
