package railcraft.common.liquids;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import net.minecraft.item.ItemStack;
import net.minecraftforge.liquids.ILiquidTank;
import railcraft.common.core.Railcraft;
import railcraft.common.gui.util.ToolTip;
import railcraft.common.liquids.tanks.FilteredTank;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class LiquidGauge {

    public final ILiquidTank tank;
    public final int x;
    public final int y;
    public final int h;
    public final int w;

    public LiquidGauge(ILiquidTank tank, int x, int y, int w, int h) {
        this.tank = tank;
        this.x = x;
        this.y = y;
        this.h = h;
        this.w = w;
    }

    public List<ToolTip> getToolTip() {
        if (tank instanceof FilteredTank) {
            return ((FilteredTank) tank).getToolTip();
        }
        List<ToolTip> list = new ArrayList<ToolTip>();
        int amount = 0;
        if (tank.getLiquid() != null && tank.getLiquid().itemID != 0 && tank.getLiquid().amount > 0) {
            ItemStack stack = tank.getLiquid().asItemStack();
            if (stack.getItem() == null) {
                return list;
            }
            list.add(new ToolTip(Railcraft.getProxy().getItemDisplayName(stack), Railcraft.getProxy().getItemRarityColor(stack)));
            amount = tank.getLiquid().amount;
        }
        list.add(new ToolTip(String.format(Locale.ENGLISH, "%,d / %,d", amount, tank.getCapacity())));
        return list;
    }
}
