/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.liquids.tanks;

import net.minecraft.item.Item;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.liquids.LiquidStack;
import net.minecraftforge.liquids.LiquidTank;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class StandardTank extends LiquidTank {

    private int tankIndex;

    public StandardTank(int capacity) {
        super(capacity);
    }

    public StandardTank(int capacity, TileEntity tile) {
        super(null, capacity, tile);
    }

    public void setTankIndex(int index) {
        this.tankIndex = index;
    }

    public int getTankIndex() {
        return tankIndex;
    }

    public boolean isEmpty() {
        return getLiquid() == null || getLiquid().amount <= 0;
    }

    public void writeToNBT(NBTTagCompound data) {
        if (getLiquid() != null && getLiquid().amount > 0) {
            getLiquid().writeToNBT(data);
        }
    }

    public void readFromNBT(NBTTagCompound data) {
        LiquidStack liquid = new LiquidStack(0, 0, 0);
        liquid.readFromNBT(data);
        if (Item.itemsList[liquid.itemID] == null || liquid.amount <= 0) {
            liquid = null;
        }
        setLiquid(liquid);
    }
}
