package railcraft.common.modules;

import buildcraft.api.power.PowerFramework;
import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import railcraft.common.api.crafting.RailcraftCraftingManager;
import railcraft.common.blocks.RailcraftBlocks;
import railcraft.common.blocks.machine.alpha.EnumMachineAlpha;
import railcraft.common.blocks.machine.beta.EnumMachineBeta;
import railcraft.common.blocks.machine.beta.PneumaticPowerFramework;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.items.ItemGear;
import railcraft.common.items.RailcraftPartItems;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.plugins.forge.CraftingPlugin;
import railcraft.common.plugins.ic2.IC2Plugin;
import railcraft.common.util.crafting.RotorRepairRecipe;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ModuleEnergy extends RailcraftModule {

    @Override
    public void initFirst() {

        if (PowerFramework.currentFramework == null) {
            PowerFramework.currentFramework = new PneumaticPowerFramework();
        }

//        LiquidItems.getSteamBottle(1);

        EnumMachineBeta beta = EnumMachineBeta.ENGINE_STEAM_HOBBY;
        if (RailcraftConfig.isSubBlockEnabled(beta.getTag())) {
            RailcraftBlocks.registerBlockMachineBeta();
            Block block = RailcraftBlocks.getBlockMachineBeta();
            if (block != null) {
                ItemStack stack = beta.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, beta.getTag());
                CraftingPlugin.addShapedRecipe(beta.getItem(), new Object[]{
                            "NNN",
                            " C ",
                            "GPG",
                            'P', new ItemStack(Block.pistonBase),
                            'N', new ItemStack(Item.goldNugget),
                            'C', new ItemStack(Block.glass),
                            'G', ItemGear.getGoldPlateGear(),});
            }
        }

        beta = EnumMachineBeta.ENGINE_STEAM_LOW;
        if (RailcraftConfig.isSubBlockEnabled(beta.getTag())) {
            RailcraftBlocks.registerBlockMachineBeta();
            Block block = RailcraftBlocks.getBlockMachineBeta();
            if (block != null) {
                ItemStack stack = beta.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, beta.getTag());
                CraftingPlugin.addShapedRecipe(beta.getItem(), new Object[]{
                            "III",
                            " C ",
                            "GPG",
                            'P', new ItemStack(Block.pistonBase),
                            'I', RailcraftPartItems.getPlateIron(),
                            'C', new ItemStack(Block.glass),
                            'G', ItemGear.getIronGear(),});

                RailcraftCraftingManager.blastFurnace.addRecipe(stack.itemID, stack.getItemDamage(), 15360, RailcraftPartItems.getIngotSteel(12));
            }
        }

        beta = EnumMachineBeta.ENGINE_STEAM_HIGH;
        if (RailcraftConfig.isSubBlockEnabled(beta.getTag())) {
            RailcraftBlocks.registerBlockMachineBeta();
            Block block = RailcraftBlocks.getBlockMachineBeta();
            if (block != null) {
                ItemStack stack = beta.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, beta.getTag());
                CraftingPlugin.addShapedRecipe(beta.getItem(), new Object[]{
                            "III",
                            " C ",
                            "GPG",
                            'P', new ItemStack(Block.pistonBase),
                            'I', RailcraftPartItems.getPlateSteel(),
                            'C', new ItemStack(Block.glass),
                            'G', ItemGear.getSteelGear(),});
            }
        }

        beta = EnumMachineBeta.BOILER_FIREBOX_SOLID;
        if (RailcraftConfig.isSubBlockEnabled(beta.getTag())) {
            RailcraftBlocks.registerBlockMachineBeta();
            Block block = RailcraftBlocks.getBlockMachineBeta();
            if (block != null) {
                ItemStack stack = beta.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, beta.getTag());
                CraftingPlugin.addShapedRecipe(beta.getItem(), new Object[]{
                            "BBB",
                            "BCB",
                            "BFB",
                            'B', new ItemStack(Item.brick),
                            'C', new ItemStack(Item.fireballCharge),
                            'F', new ItemStack(Block.stoneOvenIdle),});
            }
        }

        beta = EnumMachineBeta.BOILER_FIREBOX_LIQUID;
        if (RailcraftConfig.isSubBlockEnabled(beta.getTag())) {
            RailcraftBlocks.registerBlockMachineBeta();
            Block block = RailcraftBlocks.getBlockMachineBeta();
            if (block != null) {
                ItemStack stack = beta.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, beta.getTag());
                CraftingPlugin.addShapedRecipe(beta.getItem(), new Object[]{
                            "PBP",
                            "GCG",
                            "PFP",
                            'B', new ItemStack(Item.bucketEmpty),
                            'G', new ItemStack(Block.fenceIron),
                            'C', new ItemStack(Item.fireballCharge),
                            'P', RailcraftPartItems.getPlateSteel(),
                            'F', new ItemStack(Block.stoneOvenIdle),});
            }
        }

        beta = EnumMachineBeta.BOILER_TANK_LOW_PRESSURE;
        if (RailcraftConfig.isSubBlockEnabled(beta.getTag())) {
            RailcraftBlocks.registerBlockMachineBeta();
            Block block = RailcraftBlocks.getBlockMachineBeta();
            if (block != null) {
                ItemStack stack = beta.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, beta.getTag());
                CraftingPlugin.addShapedRecipe(beta.getItem(), new Object[]{
                            "P",
                            "P",
                            'P', RailcraftPartItems.getPlateIron(),});

                RailcraftCraftingManager.blastFurnace.addRecipe(stack.itemID, stack.getItemDamage(), 2560, RailcraftPartItems.getIngotSteel(2));
            }
        }

        beta = EnumMachineBeta.BOILER_TANK_HIGH_PRESSURE;
        if (RailcraftConfig.isSubBlockEnabled(beta.getTag())) {
            RailcraftBlocks.registerBlockMachineBeta();
            Block block = RailcraftBlocks.getBlockMachineBeta();
            if (block != null) {
                ItemStack stack = beta.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, beta.getTag());
                CraftingPlugin.addShapedRecipe(beta.getItem(), new Object[]{
                            "P",
                            "P",
                            'P', RailcraftPartItems.getPlateSteel(),});
            }
        }

        EnumMachineAlpha alpha = EnumMachineAlpha.TURBINE;
        if (RailcraftConfig.isSubBlockEnabled(alpha.getTag())) {
            RailcraftBlocks.registerBlockMachineAlpha();
            Block block = RailcraftBlocks.getBlockMachineAlpha();
            if (block != null) {
                ItemStack stack = alpha.getItem();
                RailcraftLanguage.getInstance().registerItemName(stack, alpha.getTag());

                CraftingPlugin.addShapedOreRecipe(alpha.getItem(3), new Object[]{
                            "BPB",
                            "P P",
                            "BPB",
                            'P', RailcraftPartItems.getPlateSteel(),
                            'B', "blockSteel",});

                RailcraftPartItems.getTurbineRotor();
                
                CraftingPlugin.addRecipe(new RotorRepairRecipe());
                
//                ItemStack rotor = RailcraftPartItems.getTurbineRotor();
//                rotor.setItemDamage(25000);
//                CraftingPlugin.addShapelessRecipe(rotor, RailcraftPartItems.getTurbineRotor());
            }
        }
    }

    @Override
    public void postInit() {
        IC2Plugin.nerfSyntheticCoal();
    }
}
