package railcraft.common.modules;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import railcraft.common.blocks.RailcraftBlocks;
import railcraft.common.blocks.detector.BlockDetector.Detector;
import railcraft.common.blocks.machine.gamma.EnumMachineGamma;
import railcraft.common.blocks.tracks.EnumTrack;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.items.RailcraftToolItems;
import railcraft.common.lang.RailcraftLanguage;
import railcraft.common.plugins.forge.CraftingPlugin;
import railcraft.common.util.misc.MiscTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ModuleTrain extends RailcraftModule
{

    @Override
    public void initFirst()
    {
        RailcraftBlocks.registerBlockDetector();
        RailcraftBlocks.registerBlockTrack();

        MiscTools.registerTrack(EnumTrack.BOARDING_TRAIN);
        MiscTools.registerTrack(EnumTrack.HOLDING_TRAIN);
        MiscTools.registerTrack(EnumTrack.LOCKDOWN_TRAIN);
        MiscTools.registerTrack(EnumTrack.COUPLER);
        MiscTools.registerTrack(EnumTrack.DECOUPLER);

        if(RailcraftBlocks.getBlockDetector() != null) {
            CraftingPlugin.addShapedRecipe(new ItemStack(RailcraftBlocks.getBlockDetector(), 1, Detector.TRAIN.ordinal()), new Object[]{
                    "XXX",
                    "XPX",
                    "XXX",
                    'X', Block.netherBrick,
                    'P', Block.pressurePlateStone,});
        }

        EnumMachineGamma type = EnumMachineGamma.DISPENSER_TRAIN;
        if(RailcraftConfig.isSubBlockEnabled(type.getTag())) {
            RailcraftBlocks.registerBlockMachineGamma();
            ItemStack trainDispenser = type.getItem(1);
            ItemStack crowbar = RailcraftToolItems.getCrowbar();
            crowbar.setItemDamage(-1);
            CraftingPlugin.addShapedRecipe(trainDispenser, new Object[]{
                    "rcr",
                    "cdc",
                    "rcr",
                    'd', EnumMachineGamma.DISPENSER_CART.getItem(),
                    'c', crowbar,
                    'r', Item.redstone});
            RailcraftLanguage.getInstance().registerItemName(trainDispenser, type.getTag());
        }
    }
}
