package railcraft.common.modules;

import net.minecraft.block.Block;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.oredict.ShapelessOreRecipe;
import railcraft.common.blocks.ore.BlockOre;
import railcraft.common.blocks.ore.BlockWorldLogic;
import railcraft.common.blocks.ore.EnumOre;
import railcraft.common.blocks.ore.SaltpeterDecorator;
import railcraft.common.blocks.ore.SulfurDecorator;
import railcraft.common.core.RailcraftConfig;
import railcraft.common.plugins.forestry.ForestryPlugin;
import railcraft.common.plugins.forge.CraftingPlugin;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ModuleWorld extends RailcraftModule {

    @Override
    public void initFirst() {
        BlockOre.registerBlock();
        BlockWorldLogic.registerBlock();

        if (RailcraftConfig.isWorldGenEnabled("saltpeter") && EnumOre.SALTPETER.isEnabled()) {
            MinecraftForge.ORE_GEN_BUS.register(new SaltpeterDecorator());
        }
        if (RailcraftConfig.isWorldGenEnabled("sulfur") && EnumOre.SULFUR.isEnabled()) {
            MinecraftForge.ORE_GEN_BUS.register(new SulfurDecorator());
        }

        if (RailcraftConfig.getRecipeConfig("railcraft.misc.gunpowder")) {
            IRecipe recipe = new ShapelessOreRecipe(new ItemStack(Item.gunpowder, 2), "dustSaltpeter", "dustSaltpeter", "dustSulfur", "dustCharcoal");
            CraftingManager.getInstance().getRecipeList().add(recipe);
        }

        if (RailcraftConfig.getRecipeConfig("forestry.misc.fertilizer")) {
            ItemStack fert = ForestryPlugin.getItem("fertilizerCompound");

            if (fert != null) {
                fert = fert.copy();
                fert.stackSize = 2;
                CraftingPlugin.addShapelessOreRecipe(fert,
                        "dustSaltpeter",
                        new ItemStack(Block.sand),
                        new ItemStack(Block.sand),
                        new ItemStack(Block.dirt),
                        new ItemStack(Block.dirt));
            }
        }
    }
}
