package railcraft.common.modules.orehandlers;

import java.util.logging.Level;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.oredict.OreDictionary.OreRegisterEvent;
import railcraft.common.carts.EntityTunnelBore;
import railcraft.common.util.misc.Game;

public class BoreOreHandler
{

    @ForgeSubscribe
    public void onOreEvent(OreRegisterEvent event)
    {
        String oreClass = event.Name;
        ItemStack ore = event.Ore;
        if(ore == null) {
            return;
        }
        if(ore.getItem() instanceof ItemBlock) {
            Game.log(Level.FINER, "Automation Module: Ore Detected, adding to blocks Tunnel Bore can mine: {0}, id={1} meta={2}", oreClass, ore.itemID, ore.getItemDamage());
            EntityTunnelBore.addMineableBlock(ore.itemID, ore.getItemDamage());
        }
    }
}
