package railcraft.common.plugins.buildcraft.actions;

import buildcraft.api.gates.IAction;
import buildcraft.api.gates.IActionProvider;
import java.util.LinkedList;
import net.minecraft.block.Block;
import net.minecraft.tileentity.TileEntity;
import railcraft.common.plugins.buildcraft.triggers.*;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class ActionProvider implements IActionProvider
{

    public ActionProvider()
    {
        EnumTriggerActions.init();
    }

    @Override
    public LinkedList<IAction> getNeighborActions(Block block, TileEntity tile)
    {
        LinkedList<IAction> actions = new LinkedList<IAction>();
        if(tile instanceof IHasWork) {
            actions.add(EnumTriggerActions.PAUSE.getAction());
        }
        if(tile instanceof IHasCart) {
            actions.add(EnumTriggerActions.SEND_CART.getAction());
        }
        return actions;
    }
}
