/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package railcraft.common.plugins.buildcraft.triggers;

import buildcraft.api.gates.ITrigger;
import java.util.EnumSet;
import railcraft.common.blocks.machine.beta.TileEngine.EnergyStage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public enum EnumTriggers
{

    HAS_WORK(new TriggerHasWork(400)),
    HAS_CART(new TriggerHasCart(401)),
    ENGINE_BLUE(new TriggerEngine(402, EnumSet.of(EnergyStage.BLUE), EnergyStage.BLUE.ordinal())),
    ENGINE_GREEN(new TriggerEngine(403, EnumSet.of(EnergyStage.GREEN), EnergyStage.GREEN.ordinal())),
    ENGINE_YELLOW(new TriggerEngine(404, EnumSet.of(EnergyStage.YELLOW), EnergyStage.YELLOW.ordinal())),
    ENGINE_ORANGE(new TriggerEngine(405, EnumSet.of(EnergyStage.ORANGE), EnergyStage.ORANGE.ordinal())),
    ENGINE_RED(new TriggerEngine(406, EnumSet.of(EnergyStage.RED, EnergyStage.OVERHEAT), EnergyStage.RED.ordinal())),
    LOW_FUEL(new TriggerLowFuel(407)),
    TEMP_COLD(new TriggerTemp(408, "cold", 224, 0, 100)),
    TEMP_WARM(new TriggerTemp(409, "warm", 225, 100, 300)),
    TEMP_HOT(new TriggerTemp(410, "hot", 226, 300, Integer.MAX_VALUE)),
    NEEDS_MAINT(new TriggerMaintenance(411)),
    ;
    private final ITrigger trigger;

    private EnumTriggers(ITrigger trigger) {
        this.trigger = trigger;
    }

    public ITrigger getTrigger() {
        return trigger;
    }

    public static void init() {
        // NOOP: Forces class load
    }
}
