package railcraft.common.plugins.buildcraft.triggers;

import buildcraft.api.gates.ITriggerParameter;
import java.util.EnumSet;
import net.minecraft.tileentity.TileEntity;
import railcraft.common.blocks.machine.beta.TileEngine;
import railcraft.common.blocks.machine.beta.TileEngine.EnergyStage;
import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TriggerEngine extends TriggerBase {

    private final EnumSet<EnergyStage> stages;
    private final int textureOffset;

    public TriggerEngine(int id, EnumSet<EnergyStage> stages, int textureOffset) {
        super(id);
        this.stages = stages;
        this.textureOffset = textureOffset;
    }

    @Override
    public String getDescription() {
        return RailcraftLanguage.translate("gates.trigger.engine");
    }

    @Override
    public int getIndexInTexture() {
        return textureOffset + 15 * 16;
    }

    @Override
    public boolean isTriggerActive(TileEntity tile, ITriggerParameter parameter) {
        if (tile instanceof TileEngine) {
            EnergyStage engineStage = ((TileEngine) tile).getEnergyStage();
            return stages.contains(engineStage);
        }
        return false;
    }
}
