package railcraft.common.plugins.buildcraft.triggers;

import buildcraft.api.gates.ITrigger;
import buildcraft.api.gates.ITriggerProvider;
import buildcraft.api.transport.IPipe;
import java.util.LinkedList;
import net.minecraft.block.Block;
import net.minecraft.tileentity.TileEntity;
import railcraft.common.blocks.machine.beta.TileEngine;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TriggerProvider implements ITriggerProvider
{

    public TriggerProvider() {
        EnumTriggers.init();
    }

    @Override
    public LinkedList<ITrigger> getPipeTriggers(IPipe pipe) {
        return null;
    }

    @Override
    public LinkedList<ITrigger> getNeighborTriggers(Block block, TileEntity tile) {
        LinkedList<ITrigger> triggers = new LinkedList<ITrigger>();
        if(tile instanceof IHasWork) {
            triggers.add(EnumTriggers.HAS_WORK.getTrigger());
        }
        if(tile instanceof IHasCart) {
            triggers.add(EnumTriggers.HAS_CART.getTrigger());
        }
        if(tile instanceof INeedsFuel) {
            triggers.add(EnumTriggers.LOW_FUEL.getTrigger());
        }
        if(tile instanceof TileEngine) {
            triggers.add(EnumTriggers.ENGINE_BLUE.getTrigger());
            triggers.add(EnumTriggers.ENGINE_GREEN.getTrigger());
            triggers.add(EnumTriggers.ENGINE_YELLOW.getTrigger());
            triggers.add(EnumTriggers.ENGINE_ORANGE.getTrigger());
            triggers.add(EnumTriggers.ENGINE_RED.getTrigger());
        }
        if(tile instanceof ITemperature) {
            triggers.add(EnumTriggers.TEMP_COLD.getTrigger());
            triggers.add(EnumTriggers.TEMP_WARM.getTrigger());
            triggers.add(EnumTriggers.TEMP_HOT.getTrigger());
        }
        if(tile instanceof INeedsMaintenance) {
            triggers.add(EnumTriggers.NEEDS_MAINT.getTrigger());
        }
        return triggers;
    }
}
