package railcraft.common.plugins.buildcraft.triggers;

import buildcraft.api.gates.ITriggerParameter;
import net.minecraft.tileentity.TileEntity;
import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class TriggerTemp extends TriggerBase
{

    private final int min;
    private final int max;
    private final int texture;
    private String tag;

    public TriggerTemp(int id, String tag, int texture, int min, int max) {
        super(id);
        this.tag = tag;
        this.min = min;
        this.max = max;
        this.texture = texture;
    }

    @Override
    public String getDescription() {
        return RailcraftLanguage.translate("gates.trigger.temp." + tag);
    }

    @Override
    public int getIndexInTexture() {
        return texture;
    }

    @Override
    public boolean isTriggerActive(TileEntity tile, ITriggerParameter parameter) {
        if(tile instanceof ITemperature) {
            float temp = ((ITemperature)tile).getTemperature();
            return temp >= min && temp < max;
        }
        return false;
    }
}
