package railcraft.common.plugins.craftguide;

import net.minecraft.item.ItemStack;
import railcraft.common.api.crafting.IBlastFurnaceRecipe;
import railcraft.common.api.crafting.RailcraftCraftingManager;
import railcraft.common.blocks.machine.alpha.EnumMachineAlpha;
import uristqwerty.CraftGuide.api.ItemSlot;
import uristqwerty.CraftGuide.api.RecipeGenerator;
import uristqwerty.CraftGuide.api.RecipeProvider;
import uristqwerty.CraftGuide.api.RecipeTemplate;
import uristqwerty.CraftGuide.api.SlotType;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class BlastFurnacePlugin implements RecipeProvider
{

    private final ItemSlot[] slots = new ItemSlot[3];

    public BlastFurnacePlugin() {
        slots[0] = new ItemSlot(13, 21, 16, 16);
        slots[1] = new ItemSlot(50, 21, 16, 16, true).setSlotType(SlotType.OUTPUT_SLOT);
        slots[2] = new ItemSlot(31, 39, 16, 16).setSlotType(SlotType.MACHINE_SLOT);
    }

    @Override
    public void generateRecipes(RecipeGenerator generator) {
        ItemStack furnace = EnumMachineAlpha.BLAST_FURNACE.getItem();
        if(furnace != null) {
            RecipeTemplate template = generator.createRecipeTemplate(slots, furnace, "/gui/CraftGuideRecipe.png", 1, 181, 82, 181);

            for(IBlastFurnaceRecipe recipe : RailcraftCraftingManager.blastFurnace.getRecipes()) {
                ItemStack[] items = new ItemStack[4];
                items[0] = recipe.getInput();
                items[1] = recipe.getOutput();
                items[2] = furnace;
                generator.addRecipe(template, items);
            }
        }
    }
}
