package railcraft.common.plugins.craftguide;

import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.liquids.LiquidStack;
import railcraft.common.api.crafting.ICokeOvenRecipe;
import railcraft.common.api.crafting.RailcraftCraftingManager;
import railcraft.common.blocks.machine.alpha.EnumMachineAlpha;
import railcraft.common.core.RailcraftConstants;
import railcraft.common.liquids.LiquidManager;
import uristqwerty.CraftGuide.api.ItemSlot;
import uristqwerty.CraftGuide.api.LiquidSlot;
import uristqwerty.CraftGuide.api.RecipeGenerator;
import uristqwerty.CraftGuide.api.RecipeProvider;
import uristqwerty.CraftGuide.api.RecipeTemplate;
import uristqwerty.CraftGuide.api.Slot;
import uristqwerty.CraftGuide.api.SlotType;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class CokeOvenPlugin implements RecipeProvider {

    private final Slot[] slots = new Slot[4];

    public CokeOvenPlugin() {
        slots[0] = new ItemSlot(8, 8, 16, 16, true);
        slots[1] = new ItemSlot(55, 8, 16, 16, true).setSlotType(SlotType.OUTPUT_SLOT);
        slots[2] = new LiquidSlot(55, 34).setSlotType(SlotType.OUTPUT_SLOT);
        slots[3] = new ItemSlot(8, 34, 16, 16).setSlotType(SlotType.MACHINE_SLOT);
    }

    @Override
    public void generateRecipes(RecipeGenerator generator) {
        ItemStack oven = EnumMachineAlpha.COKE_OVEN.getItem();
        if (oven != null) {
            RecipeTemplate template = generator.createRecipeTemplate(slots, oven, RailcraftConstants.GUI_TEXTURE_FOLDER + "gui_craft_guide.png", 1, 1, 82, 1);

            for (ICokeOvenRecipe recipe : RailcraftCraftingManager.cokeOven.getRecipes()) {
                Object[] items = new Object[4];
                items[0] = recipe.getInput();
//                items[0].stackSize *= LiquidManager.BUCKET_VOLUME / recipe.getLiquidOutput().amount;
                items[1] = recipe.getOutput();
//                if (items[1] != null) {
//                    items[1].stackSize *= LiquidManager.BUCKET_VOLUME / recipe.getLiquidOutput().amount;
//                }
                items[2] = recipe.getLiquidOutput();
                items[3] = oven;
                generator.addRecipe(template, items);
            }
        }
    }
}
