package railcraft.common.plugins.craftguide;

import java.lang.reflect.Method;
import java.util.logging.Level;
import railcraft.common.util.misc.Game;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class CraftGuidePlugin {

    private static Method register;

    public static void init() {
        try {
            registerCraftGuideObject(new BlastFurnacePlugin());
            registerCraftGuideObject(new CokeOvenPlugin());
            registerCraftGuideObject(new RockCrusherPlugin());
            registerCraftGuideObject(new RollingMachinePlugin());
            registerCraftGuideObject(new RecipeFilter());
        } catch (Throwable error) {
            Game.log(Level.FINEST, "Could not register CraftGuide plugins: {0}", error.getMessage());
        }
    }

    public static void registerCraftGuideObject(Object obj) {
        try {
            if (register == null) {
                Class api = Class.forName("uristqwerty.CraftGuide.ReflectionAPI");
                register = api.getMethod("registerAPIObject", Object.class);
            }
            register.invoke(null, obj);
            Game.log(Level.FINEST, "Successfully registered CraftGuide plugin: {0}", obj.getClass().getSimpleName());
        } catch (Exception e) {
            Game.log(Level.FINEST, "Could not register CraftGuide plugin: {0}", obj.getClass().getSimpleName());
        }
    }
}
