/*
 * Copyright (c) CovertJaguar, 2011 http://railcraft.info
 * 
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.plugins.forestry;

import forestry.api.storage.IBackpackDefinition;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import railcraft.common.util.inventory.InvTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public abstract class BaseBackpack implements IBackpackDefinition {
    protected List<ItemStack> items = new ArrayList<ItemStack>(50);

    @Override
    public void addValidItem(ItemStack stack) {
        if (stack == null) return;
        items.add(stack);
    }

    public void addValidItem(Item item) {
        if (item == null) return;
        items.add(new ItemStack(item, 1, -1));
    }

    public void addValidItem(Block block) {
        if (block == null) return;
        items.add(new ItemStack(block, 1, -1));
    }

    @Override
    public Collection<ItemStack> getValidItems(EntityPlayer player) {
        return items;
    }

    @Override
    public boolean isValidItem(EntityPlayer player, ItemStack pickup) {
        for (ItemStack stack : items) {
            if (InvTools.isItemEqualIgnoreNBT(stack, pickup)) {
                return true;
            }
        }
        return false;
    }
    
}
