/*
 * Copyright (c) CovertJaguar, 2011 http://railcraft.info
 * 
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.plugins.forestry;

import cpw.mods.fml.common.ITickHandler;
import cpw.mods.fml.common.TickType;
import java.util.EnumSet;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class IceManTickHandler implements ITickHandler {

    private static EnumSet<TickType> tickTypes = EnumSet.of(TickType.PLAYER);

    @Override
    public void tickStart(EnumSet<TickType> type, Object... tickData) {
        EntityPlayer player = (EntityPlayer) tickData[0];
        if(player.openContainer != player.inventoryContainer) return;
        for (ItemStack stack : player.inventory.mainInventory) {
            if (stack == null || stack.getItem() == null) continue;
            if (stack.getItem() == ForestryPlugin.icemanBackpackT1 || stack.getItem() == ForestryPlugin.icemanBackpackT2) {
                IcemanBackpack.getInstance().compactInventory(stack);
            }
        }
    }

    @Override
    public void tickEnd(EnumSet<TickType> type, Object... tickData) {
    }

    @Override
    public EnumSet<TickType> ticks() {
        return tickTypes;
    }

    @Override
    public String getLabel() {
        return "Iceman Backpack Ticker";
    }
}
