/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.plugins.forge;

import cpw.mods.fml.common.registry.GameRegistry;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.item.crafting.IRecipe;
import net.minecraftforge.oredict.ShapedOreRecipe;
import net.minecraftforge.oredict.ShapelessOreRecipe;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class CraftingPlugin {

    public static void addFurnaceRecipe(ItemStack input, ItemStack output, float xp) {
        FurnaceRecipes.smelting().addSmelting(input.itemID, input.getItemDamage(), output, xp);
    }

    public static void addShapedRecipe(ItemStack result, Object... input) {
        for (Object obj : input) {
            if (obj instanceof String && ((String) obj).length() > 3) {
                throw new RuntimeException("CJ you're a noob, you used the wrong function again!");
            }
        }
        GameRegistry.addRecipe(result, input);
    }

    public static void addShapelessRecipe(ItemStack result, Object... input) {
        GameRegistry.addShapelessRecipe(result, input);
    }

    public static void addShapedOreRecipe(ItemStack result, Object... input) {
        IRecipe recipe = new ShapedOreRecipe(result, input);
        addRecipe(recipe);
    }

    public static void addShapelessOreRecipe(ItemStack result, Object... input) {
        IRecipe recipe = new ShapelessOreRecipe(result, input);
        addRecipe(recipe);
    }

    public static void addRecipe(IRecipe recipe) {
        GameRegistry.addRecipe(recipe);
    }
}
