/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.plugins.forge;

import net.minecraft.item.ItemStack;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraftforge.common.ChestGenHooks;
import railcraft.common.core.RailcraftConfig;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class LootPlugin {

    public static void increaseLootGen(int min, int max, String... locations) {
        for (String location : locations) {
            ChestGenHooks lootInfo = ChestGenHooks.getInfo(location);
            lootInfo.setMin(lootInfo.getMin() + min);
            lootInfo.setMax(lootInfo.getMax() + max);
        }
    }

    public static void addLoot(ItemStack loot, int minStack, int maxStack, String tag, String... locations) {
        WeightedRandomChestContent contents = new WeightedRandomChestContent(loot, minStack, maxStack, RailcraftConfig.getLootChance(tag));
        addLoot(contents, locations);
    }

    public static void addLoot(WeightedRandomChestContent loot, String... locations) {
        for (String location : locations) {
            ChestGenHooks.addItem(location, loot);
        }
    }

    public static void addLootWarrior(ItemStack loot, int minStack, int maxStack, String tag) {
        addLoot(loot, minStack, maxStack, tag,
                ChestGenHooks.VILLAGE_BLACKSMITH,
                ChestGenHooks.DUNGEON_CHEST,
                ChestGenHooks.PYRAMID_DESERT_CHEST,
                ChestGenHooks.PYRAMID_JUNGLE_CHEST,
                ChestGenHooks.STRONGHOLD_CORRIDOR,
                ChestGenHooks.STRONGHOLD_CROSSING);
    }

    public static void addLootMineshaft(ItemStack loot, int minStack, int maxStack, String tag) {
        addLoot(loot, minStack, maxStack, tag, ChestGenHooks.MINESHAFT_CORRIDOR);
    }

    public static void addLootTool(ItemStack loot, int minStack, int maxStack, String tag) {
        addLoot(loot, minStack, maxStack, tag,
                ChestGenHooks.MINESHAFT_CORRIDOR,
                ChestGenHooks.VILLAGE_BLACKSMITH);
    }
}
