/*
 * Copyright (c) CovertJaguar, 2011 http://railcraft.info
 * 
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.plugins.forge;

import java.util.List;
import net.minecraft.item.ItemStack;
import net.minecraftforge.oredict.OreDictionary;
import railcraft.common.util.inventory.InvTools;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class OreDictPlugin {

    public static String getOreName(ItemStack ore) {
        return OreDictionary.getOreName(OreDictionary.getOreID(ore));
    }

    public static boolean isOreType(String oreName, ItemStack stack) {
        List<ItemStack> ores = OreDictionary.getOres(oreName);
        for (ItemStack ore : ores) {
            if (InvTools.isItemEqual(ore, stack)) {
                return true;
            }
        }
        return false;
    }
}
