package railcraft.common.util.crafting;

import cpw.mods.fml.common.ICraftingHandler;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import railcraft.common.carts.EnumCart;
import railcraft.common.carts.ItemCart;
import railcraft.common.liquids.LiquidManager;

public class CraftingHandler implements ICraftingHandler
{

    @Override
    public void onCrafting(EntityPlayer player, ItemStack result, IInventory craftMatrix)
    {
        int count = 0;
        ItemStack cartItem = null;
        for(int i = 0; i < craftMatrix.getSizeInventory(); i++) {
            ItemStack stack = craftMatrix.getStackInSlot(i);
            if(stack != null) {
                count++;
                if(stack.getItem() != null && stack.getItem() instanceof ItemCart && ItemCart.getCartType(stack) != EnumCart.BASIC) {
                    cartItem = stack;
                }
            }
        }
        if(cartItem != null) {

            if(ItemCart.getCartType(result) == EnumCart.TANK && ItemCart.getCartType(cartItem) == EnumCart.TANK) {
                if(result.getItemDamage() > 0) {
                    for(int i = 0; i < craftMatrix.getSizeInventory(); i++) {
                        ItemStack stack = craftMatrix.getStackInSlot(i);
                        if(stack != null && LiquidManager.getInstance().isContainer(stack)) {
                            if(!player.inventory.addItemStackToInventory(stack)) {
                                player.dropPlayerItem(stack);
                            }
                            craftMatrix.setInventorySlotContents(i, null);
                        }
                    }
                }
                return;
            }

            if(count == 1 && ItemCart.getCartType(result) == EnumCart.BASIC) {
                ItemStack contents = ItemCart.getCartType(cartItem).getContents();
                if(contents != null) {
                    if(!player.inventory.addItemStackToInventory(contents)) {
                        for(int j = 0; j < craftMatrix.getSizeInventory(); j++) {
                            ItemStack slot = craftMatrix.getStackInSlot(j);
                            if(slot == null) {
                                contents.stackSize += 1;
                                craftMatrix.setInventorySlotContents(j, contents);
                                return;
                            }
                        }
                        player.dropPlayerItem(contents);
                    }
                }
            }
        }
    }

    @Override
    public void onSmelting(EntityPlayer player, ItemStack item)
    {
    }
}
