/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.util.effects;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Random;
import java.util.Set;
import net.minecraft.world.ChunkCoordIntPair;
import net.minecraft.entity.Entity;
import net.minecraft.client.particle.EntityFX;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import railcraft.common.util.misc.Game;
import railcraft.common.util.network.PacketEffect;
import railcraft.common.util.network.PacketEffect.Effect;
import railcraft.common.util.sounds.SoundHelper;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class CommonProxy implements IEffectManager {

    protected static final Random rand = new Random();

    @Override
    public void teleportEffect(Entity entity, double destX, double destY, double destZ) {
        if (Game.isNotHost(entity.worldObj)) {
            return;
        }

        try {
            PacketEffect pkt = new PacketEffect(Effect.TELEPORT);
            DataOutputStream data = pkt.getOutputStream();
            data.writeDouble(entity.posX);
            data.writeDouble(entity.posY);
            data.writeDouble(entity.posZ);
            data.writeDouble(destX);
            data.writeDouble(destY);
            data.writeDouble(destZ);
            pkt.sendPacket(entity.worldObj, entity.posX, entity.posY, entity.posZ);
        } catch (IOException ex) {
        }


        SoundHelper.playSoundAtEntity(entity, "mob.endermen.portal", 0.25F, 1.0F);
    }

    @Override
    public boolean isAnchorAuraActive() {
        return false;
    }

    @Override
    public boolean isTuningAuraActive() {
        return false;
    }

    @Override
    public void tuningEffect(TileEntity start, TileEntity dest) {
    }

    @Override
    public void chunkLoaderEffect(World world, Object source, Set<ChunkCoordIntPair> chunks) {
    }

    @Override
    public void handleEffectPacket(DataInputStream data) throws IOException {
    }

    protected void spawnParticle(EntityFX particle) {
    }

    @Override
    public void steamEffect(World world, Object source, double yOffset) {
    }
}
