/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.util.effects;

import java.io.DataInputStream;
import java.io.IOException;
import java.util.Set;
import net.minecraft.world.ChunkCoordIntPair;
import net.minecraft.entity.Entity;
import net.minecraft.world.World;
import railcraft.common.api.signals.IPairEffectRenderer;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public interface IEffectManager extends IPairEffectRenderer {

    void chunkLoaderEffect(World world, Object source, Set<ChunkCoordIntPair> chunks);
    
    boolean isAnchorAuraActive();

    void handleEffectPacket(DataInputStream data) throws IOException;

    void steamEffect(World world, Object source, double yOffset);

    void teleportEffect(Entity entity, double destX, double destY, double destZ);
}
