package railcraft.common.util.inventory;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import net.minecraft.item.ItemStack;

public class ItemStackSizeSorter implements Comparator<ItemStack>
{

    private static ItemStackSizeSorter instance;

    private static ItemStackSizeSorter getInstance()
    {
        if(instance == null) {
            instance = new ItemStackSizeSorter();
        }
        return instance;
    }

    public static void sort(List<ItemStack> list)
    {
        Collections.sort(list, getInstance());
    }

    @Override
    public int compare(ItemStack o1, ItemStack o2)
    {
        Integer size1 = o1.stackSize;
        Integer size2 = o2.stackSize;
        return size1.compareTo(size2);
    }
}
