package railcraft.common.util.inventory;

import net.minecraft.inventory.IInventory;

/**
 * Creates a standalone instance of IInventory of max stacksize = 127.
 *
 * Useful for creating filter inventories.
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class PhantomInventory extends StandaloneInventory
{

    public PhantomInventory(int size, String name, IInventory callback)
    {
        super(size, name, callback);
    }

    public PhantomInventory(int size, IInventory callback)
    {
        super(size, null, callback);
    }

    public PhantomInventory(int size, String name)
    {
        super(size, name);
    }

    public PhantomInventory(int size)
    {
        super(size, null, (IInventory)null);
    }

    @Override
    protected String invTypeName()
    {
        return "Phantom";
    }

    @Override
    public int getInventoryStackLimit()
    {
        return 127;
    }
}
