package railcraft.common.util.inventory;

import buildcraft.api.inventory.ISpecialInventory;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.ForgeDirection;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class SpecialInventoryMapper extends InventoryMapper implements ISpecialInventory
{

    private final ISpecialInventory inv;
    protected final ForgeDirection side;

    public SpecialInventoryMapper(ISpecialInventory inv, ForgeDirection side)
    {
        super(inv, side);
        this.inv = inv;
        this.side = side;
    }

    @Override
    public int addItem(ItemStack stack, boolean doAdd, ForgeDirection from)
    {
        return inv.addItem(stack, doAdd, side);
    }

    @Override
    public ItemStack[] extractItem(boolean doRemove, ForgeDirection from, int maxItemCount)
    {
        return inv.extractItem(doRemove, side, maxItemCount);
    }
}
