package railcraft.common.util.misc;

import cpw.mods.fml.common.IScheduledTickHandler;
import cpw.mods.fml.common.TickType;
import java.util.EnumSet;
import railcraft.common.api.signals.SignalAspect;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class BlinkTick implements IScheduledTickHandler
{

    private static EnumSet<TickType> tickType = EnumSet.of(TickType.CLIENT);

    @Override
    public int nextTickSpacing()
    {
        return 10;
    }

    @Override
    public void tickStart(EnumSet<TickType> type, Object... tickData)
    {
        SignalAspect.invertBlinkState();
    }

    @Override
    public void tickEnd(EnumSet<TickType> type, Object... tickData)
    {
    }

    @Override
    public EnumSet<TickType> ticks()
    {
        return tickType;
    }

    @Override
    public String getLabel()
    {
        return "Railcraft Blink Tick";
    }
}
