/*
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.util.misc;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class BlockKey {

    public final int blockID;
    public final int metadata;

    public BlockKey(int blockID, int metadata) {
        this.blockID = blockID;
        this.metadata = metadata;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 73 * hash + this.blockID;
        hash = 73 * hash + this.metadata;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) return false;
        if (getClass() != obj.getClass()) return false;
        final BlockKey other = (BlockKey) obj;
        if (this.blockID != other.blockID) return false;
        if (this.metadata != other.metadata) return false;
        return true;
    }
}
