/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package railcraft.common.util.misc;

import railcraft.common.lang.RailcraftLanguage;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public enum EnumColor {

    BLACK(0x2D2D2D),
    RED(0xA33835),
    GREEN(0x394C1E),
    BROWN(0x5C3A24),
    BLUE(0x3441A2),
    PURPLE(0x843FBF),
    CYAN(0x36809E),
    LIGHT_GRAY(0x888888),
    GRAY(0x444444),
    PINK(0xE585A0),
    LIME(0x3FAA36),
    YELLOW(0xCFC231),
    LIGHT_BLUE(0x7F9AD1),
    MAGENTA(0xFF64FF),
    ORANGE(0xFF6A00),
    WHITE(0xFFFFFF);
    public final static EnumColor[] VALUES = values();
    public final static String[] DYES = {
        "dyeBlack",
        "dyeRed",
        "dyeGreen",
        "dyeBrown",
        "dyeBlue",
        "dyePurple",
        "dyeCyan",
        "dyeLightGray",
        "dyeGray",
        "dyePink",
        "dyeLime",
        "dyeYellow",
        "dyeLightBlue",
        "dyeMagenta",
        "dyeOrange",
        "dyeWhite"};
    private final int color;

    private EnumColor(int color) {
        this.color = color;
    }

    public int getHexColor() {
        return color;
    }

    public static EnumColor fromId(int id) {
        if (id < 0 || id >= VALUES.length) {
            return WHITE;
        }
        return VALUES[id];
    }

    public static EnumColor fromDye(String dyeTag) {
        for (int id = 0; id < DYES.length; id++) {
            if (DYES[id].equals(dyeTag)) {
                return VALUES[id];
            }
        }
        return null;
    }

    public static EnumColor getRand() {
        return VALUES[MiscTools.getRand().nextInt(VALUES.length)];
    }

    public String getTag() {
        return "color." + name().replace("_", ".").toLowerCase();
    }

    public String getBasicTag() {
        return name().replace("_", ".").toLowerCase();
    }

    public String getTranslatedName() {
        return RailcraftLanguage.translate(getTag());
    }

    public String getDye() {
        return DYES[ordinal()];
    }

    @Override
    public String toString() {
        String s = name().replace("_", " ");
        String[] words = s.split(" ");
        StringBuilder b = new StringBuilder();
        for (String word : words) {
            b.append(word.charAt(0)).append(word.substring(1).toLowerCase()).append(" ");
        }
        return b.toString().trim();
    }
}
