package railcraft.common.util.misc;

import net.minecraft.block.Block;

public class FakeBlockRenderInfo
{

    public Block template = Block.stone;
    public int[] texture = new int[]{-1};
    public float minX = 0;
    public float minY = 0;
    public float minZ = 0;
    public float maxX = 1;
    public float maxY = 1;
    public float maxZ = 1;
    public boolean renderTop = true;
    public boolean renderBottom = true;
    public boolean renderNorth = true;
    public boolean renderSouth = true;
    public boolean renderEast = true;
    public boolean renderWest = true;
    public float light = -1f;
    public int brightness = -1;

    public FakeBlockRenderInfo()
    {
    }

    public FakeBlockRenderInfo(Block template, int[] texture)
    {
        this.template = template;
        this.texture = texture;
    }

    public FakeBlockRenderInfo(float minX, float minY, float minZ, float maxX, float maxY, float maxZ)
    {
        this.minX = minX;
        this.minY = minY;
        this.minZ = minZ;
        this.maxX = maxX;
        this.maxY = maxY;
        this.maxZ = maxZ;
    }

    public void rotate()
    {
        float temp = minX;
        minX = minZ;
        minZ = temp;

        temp = maxX;
        maxX = maxZ;
        maxZ = temp;
    }

    public void reverseX()
    {
        float temp = minX;
        minX = 1 - maxX;
        maxX = 1 - temp;
    }

    public void reverseZ()
    {
        float temp = minZ;
        minZ = 1 - maxZ;
        maxZ = 1 - temp;
    }

    public int getBlockTextureFromSide(int i)
    {
        if(texture[0] == -1) {
            return template.getBlockTextureFromSide(i);
        } else {
            if(i >= texture.length) {
                i = 0;
            }
            return texture[i];
        }
    }
}
