package railcraft.common.util.network;

import cpw.mods.fml.client.FMLClientHandler;
import cpw.mods.fml.common.network.PacketDispatcher;
import cpw.mods.fml.common.network.Player;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import net.minecraft.client.entity.EntityClientPlayerMP;
import net.minecraft.entity.player.EntityPlayer;

public class PacketGuiUpdate extends RailcraftPacket
{

    private int windowId, dataId, value;

    public PacketGuiUpdate() {
        super();
    }

    public PacketGuiUpdate(int windorId, int dataId, int value) {
        this.windowId = windorId;
        this.dataId = dataId;
        this.value = value;
    }

    public void sendPacket(EntityPlayer player) {
        PacketDispatcher.sendPacketToPlayer(getPacket(), (Player)player);
    }

    @Override
    public void writeData(DataOutputStream data) throws IOException {
        data.writeByte(windowId);
        data.writeByte(dataId);
        data.writeInt(value);
    }

    @Override
    public void readData(DataInputStream data) throws IOException {
        windowId = data.readByte();
        dataId = data.readByte();
        value = data.readInt();

        EntityClientPlayerMP player = FMLClientHandler.instance().getClient().thePlayer;

        if(player.openContainer != null && player.openContainer.windowId == windowId) {
            player.openContainer.updateProgressBar(dataId, value);
        }
    }

    @Override
    public int getID() {
        return PacketType.GUI_UPDATE.ordinal();
    }
}
