package railcraft.common.util.network;

import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import net.minecraft.network.packet.Packet;
import net.minecraft.network.packet.Packet250CustomPayload;

public abstract class RailcraftPacket {

    public final static String CHANNEL_NAME = "RC";

    public enum PacketType {

        TILE_ENTITY,
        GUI_RETURN,
        TILE_EXTRA_DATA,
        TILE_REQUEST,
        GUI_UPDATE,
        EFFECT,
        CONTROLLER_REQUEST, CONTROLLER_UPDATE,
        RECEIVER_REQUEST, RECEIVER_UPDATE,}

    public Packet getPacket() {

        ByteArrayOutputStream bytes = new ByteArrayOutputStream();
        DataOutputStream data = new DataOutputStream(bytes);
        try {
            data.writeByte(getID());
            writeData(data);
        } catch (IOException e) {
            e.printStackTrace();
        }
        Packet250CustomPayload pkt = new Packet250CustomPayload();
        pkt.channel = CHANNEL_NAME;
        pkt.data = bytes.toByteArray();
        pkt.length = pkt.data.length;
        return pkt;
    }

    public abstract void writeData(DataOutputStream data) throws IOException;

    public abstract void readData(DataInputStream data) throws IOException;

    public abstract int getID();

    @Override
    public String toString() {
        return getClass().getSimpleName();
    }
}
