/*
 * Copyright (c) CovertJaguar, 2011 http://railcraft.info
 * 
 * This code is the property of CovertJaguar
 * and may only be used with explicit written
 * permission unless otherwise specified on the
 * license page at railcraft.wikispaces.com.
 */
package railcraft.common.util.sounds;

import net.minecraft.block.StepSound;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.World;
import railcraft.common.core.RailcraftConfig;

/**
 *
 * @author CovertJaguar <railcraft.wikispaces.com>
 */
public class SoundHelper {

    public static void playSound(World world, int x, int y, int z, String name, float volume, float pitch) {
        if (RailcraftConfig.playSounds()) {
            world.playSoundEffect(x, y, z, name, volume, pitch);
        }
    }

    public static void playSoundAtEntity(Entity entity, String name, float volume, float pitch) {
        if (RailcraftConfig.playSounds()) {
            entity.worldObj.playSoundAtEntity(entity, name, volume, pitch);
        }
    }

    public static void playBlockSound(World world, int x, int y, int z, String soundName, float volume, float pitch, int blockID, int meta) {
        if (world != null && soundName != null) {
            if (soundName.contains("railcraft")) {
                StepSound sound = SoundRegistry.getSound(blockID, meta);
                if (sound != null) {
                    String newName = soundName.contains("dig") ? sound.getBreakSound() : soundName.contains("step") ? sound.getStepSound() : sound.getPlaceSound();
                    world.playSoundEffect(x, y, z, newName, volume, pitch * sound.getPitch());
                }
            }
            world.playSoundEffect(x, y, z, soundName, volume, pitch);
        }
    }

    public static void playFX(World world, EntityPlayer player, int id, int x, int y, int z, int data) {
        if (RailcraftConfig.playSounds()) {
            world.playAuxSFXAtEntity(player, id, x, y, z, data);
        }
    }
}
